	.include "pm_libs/pm_init.s"
	.include "pm_libs/pm_cstyle.s"

	PM_HEADER "TestFramebuf", IRQ_KEY_POWER, 0

	.include "pm_libs/pmrom_cstd.s"
	.include "pm_libs/pmrom_clcd.s"

	; Shutdown down when power key pressed
irq_key_power:
	cint CINT_SHUTDOWN

main:
	; Enable interrupts
	enable_irqs IRQ_KEY_POWER | IRQ_PRC_COPY	; PRC_COPY declared to wake up HALT
	enable_mirq

	; Set contrast to 0 (full white)
	c_lcd_contrast 0

	; Setup PRC
	mov [n+PRC_MODE], PRC_ENABLE
	mov [n+PRC_RATE], PRC_24FPS

	; Copy image to VRAM
	c_memcpy VRAM_BASE, teampokeme, 768

	; Fade in (approx. 1 sec)
	c_lcd_fade $001F, 2048

	; Wait for any key press
:	halt
	c_keypad
	cmp a, 0
	jzb :b

	; Fade out
	c_lcd_fade $1F00, 2048

	; Shutdown
	cint CINT_SHUTDOWN

	pm_align_tiles
teampokeme:
	.incbin "teampokeme.bin"

	pm_rominfo
