	.include "pm_libs/pm_init.s"
	.include "pm_libs/pm_cstyle.s"

	pm_header "TestInfoDebg", IRQ_KEY_POWER, 0

	.include "pm_libs/pmrom_cstd.s"
	.include "pm_libs/pmrom_cout.s"
	.include "pm_libs/pmrom_cstr.s"
	.include "pm_libs/pmrom_cmath.s"

	; Display debug messages from cstyle
	.define PM_DEBUG

	; Shutdown down when power key pressed
irq_key_power:
	cint CINT_SHUTDOWN

initscreen:
	;    0123456789AB
	.db " Info       "
	.db " ---------- "
	.db "trololololol"
	.db "            "
	.db "            "
	.db "            "
	.db "            "
	.db "            "

	; Main routine
main:
	mov ba, MAP_BASE
	c_str_printf8 REG_BA, $0040

	; Enable interrupts
	enable_irqs IRQ_KEY_POWER | IRQ_PRC_COPY
	enable_mirq

	; Setup PRC
	mov [n+PRC_RATE], PRC_24FPS
	mov [n+PRC_MODE], PRC_ENABLE | PRC_MAP | PRC_MAP12x16
	mov hl, font8x8
	mov [PRC_MAP_BASE], hl

	; Copy initial screen into the map
	c_memcpy MAP_BASE, initscreen, 12*8

	; Do some output into the debugger first
	c_out_clear
	c_out_puts "Hello world from debugger!"

	c_out_prints "1337 * -11 = "
	c_smul 1337, -11
	c_out_printsw REG_BA
	c_out_printc 10	; New-line

	c_out_prints "Sqrt(256) = "
	c_sqrt 256
	c_out_printuw REG_BA
	c_out_printc 10	; New-line

	c_out_prints "Sin 45\' = "
	c_sin 0x20
	c_out_printf8 REG_BA
	c_out_printc 10	; New-line

	c_out_prints "Atan2(20, 20) = "
	c_atan2 20, 20
	c_smul REG_BA, 360
	c_out_printf8 REG_BA
	c_out_printc '\''
	c_out_printc 10	; New-line

	c_out_prints "-11/3 = "
	c_sdiv -11 * 256, 3	; Multiply by 256 for fixed point result
	c_out_printf8 REG_BA
	c_out_printc 10	; New-line

	; Now do on the screen
	; Note c_str functions can't handle new-lines!
	mov ba, MAP_BASE + (0 * 12) + 6
	c_str_prints REG_BA, "Debug"

	mov ba, MAP_BASE + (2 * 12) + 0
	c_str_prints REG_BA, "Hello World!"

	mov ba, MAP_BASE + (4 * 12) + 1
	c_str_prints REG_BA, "-2*5="
	push ba
	c_smul -2, 5
	mov x, ba
	pop ba
	c_str_printsw REG_BA, REG_X

	mov ba, MAP_BASE + (5 * 12) + 1
	c_str_prints REG_BA, "1024="
	push ba
	c_sqrt 1024
	mov x, ba
	pop ba
	c_str_printuw REG_BA, REG_X

	mov ba, MAP_BASE + (6 * 12) + 0
	c_str_prints REG_BA, "Sin 45="
	push ba
	c_sin 0x20
	mov x, ba
	pop ba
	c_str_printf8 REG_BA, REG_X

	mov ba, MAP_BASE + (7 * 12) + 1
	c_str_prints REG_BA, "-11/3="
	push ba
	c_sdiv -11 * 256, 3	; Multiply by 256 for fixed point result
	mov x, ba
	pop ba
	push x
	c_str_printf8 REG_BA, REG_X

:	halt
	jmpb :b

	; DOS text graphics
	pm_align_tiles
font8x8:
	.incbin "pm_libs/font8x8.bin"

	pm_rominfo
