	.include "pm_libs/pm_init.s"
	.include "pm_libs/pm_cstyle.s"

	pm_header "MapVie16Mono", IRQ_KEY_POWER, 0

	.include "pm_libs/pmrom_cstd.s"
	.include "pm_libs/pmrom_cmap16.s"

	; Shutdown down when power key pressed
irq_key_power:
	cint CINT_SHUTDOWN

.define move_speed	16

	; Main routine
main:
	; Setup PRC
	mov [n+PRC_MODE], PRC_ENABLE | PRC_MAP | PRC_MAP16x12
	mov [n+PRC_RATE], PRC_36FPS
	mov ba, tileset
	mov [PRC_MAP_BASE], ba

	; Enable interrupts
	enable_irqs IRQ_KEY_POWER | IRQ_PRC_COPY
	enable_mirq

	; Set map
	c_map16_set basicmap_mapw, basicmap_maph, basicmap

loop:
	; Battery likes HALT but be careful that it needs IRQs to wake up
	halt

	; Render map
	c_map16_draw

	; Move
	c_keypad
	tst a, KEY_LEFT
	callnzw _left
	tst a, KEY_RIGHT
	callnzw _right
	tst a, KEY_UP
	callnzw _up
	tst a, KEY_DOWN
	callnzw _down

	jmpb loop

_left:
	push ba
	c_map16_movex -move_speed
	pop ba
	ret

_right:
	push ba
	c_map16_movex move_speed
	pop ba
	ret

_up:
	push ba
	c_map16_movey -move_speed
	pop ba
	ret

_down:
	push ba
	c_map16_movey move_speed
	pop ba
	ret

basicmap:
	.include "basicmap.inc"
	.incbin "basicmap.map"

	pm_align_map
tileset:
	.incbin "tileset16.bin"

	pm_rominfo
