	.include "pm_libs/pm_init.s"
	.include "pm_libs/pm_cstyle.s"

	pm_header "TestFramebuf", IRQ_KEY_POWER, 0

	.include "pm_libs/pmrom_cstd.s"
	.include "pm_libs/pmrom_cmath.s"
	.include "pm_libs/pmrom_cstr.s"

	; Shutdown down when power key pressed
irq_key_power:
	cint CINT_SHUTDOWN

main:
	; Enable interrupts
	enable_irqs IRQ_KEY_POWER
	enable_mirq

	; Setup PRC
	mov [n+PRC_MODE], PRC_ENABLE | PRC_MAP | PRC_MAP12x16
	mov [n+PRC_RATE], PRC_24FPS
	mov ba, font8x8
	mov [PRC_MAP_BASE], ba

	; Clear screen
	c_memset VRAM_BASE, 0, 12*16

	; Setup timer 1 but don't enable
	mov [n+TMR1_ENA_OSC], TMRS_ENABLE | TMRS_OSC1
	mov [n+TMR1_SCALE], TMR_DIV_2
	mov ba, $FFFF
	mov [REG_BASE+TMR1_PRE], ba
	mov [n+TMR1_CTRL], TMR_16BITS

	; Print some text
	c_str_prints MAP_BASE+(1*12), "1260/9="
	mov hl, ba

	; Start profiling, PRC and INTs must be off
	disable_mirq
	and [n+PRC_MODE], ~PRC_ENABLE
	or [n+TMR1_CTRL], TMR_ENABLE | TMR_RESET

	; c_udiv 1260, 9
	c_udiv 1260, 9

	; End profiling, restore PRC and INTs if needed
	and [n+TMR1_CTRL], ~TMR_ENABLE
	or [n+PRC_MODE], PRC_ENABLE
	enable_mirq

	; Print result
	c_str_printuw REG_HL, REG_BA
	
	; Display time took
	mov ba, [REG_BASE+TMR1_CNT]
	not b
	not a
	sub ba, 10
	add ba, ba
	mov hl, ba

	c_str_prints MAP_BASE+(3*12), "Time taken:"
	c_str_printuw MAP_BASE+(4*12), REG_HL
	c_str_prints REG_BA, " cycles"

	; Infinite loop
:	halt
	jzb :b

	pm_rominfo

	pm_align_map
font8x8:
	.incbin "pm_libs/font8x8.bin"
