	.include "pm_libs/pminit.s"

	HEADER "HmBw", "TestFramebuf", IRQ_KEY_POWER, 0

	; Shutdown down when power key pressed
irq_key_power:
	cint CINT_SHUTDOWN

main:
	; Legacy pminit require pm_init for initialization
	pm_init

	; Enable interrupts
	mov [n+IRQ_PRI1], IRQ_PRI1_PRC
	mov [n+IRQ_PRI2], IRQ_PRI2_KEY_PAD
	mov [n+IRQ_PRI3], 0
	mov [n+IRQ_ENA1], IRQ_ENA1_PRC_COPY
	mov [n+IRQ_ENA3], IRQ_ENA3_KEY_POWER
	mov f, ENABLE_IRQ

	; Blank LCD
	mov a, 0
	cint CINT_TMP_CONTRAST

	; Setup PRC
	mov [n+PRC_MODE], PRC_ENABLE
	mov [n+PRC_RATE], PRC_24FPS

	; Copy image to VRAM
	mov y, teampokeme
	mov x, VRAM_BASE
	mov hl, 768
_vramloop:
	mov a, [y]
	mov [x], a
	inc x
	inc y
	dec hl
	jnzb _vramloop

	; Fade in
	mov a, 0
_fadeloop:
	push a
	cint CINT_TMP_CONTRAST
	pop a
	halt
	inc a
	cmp a, $20
	jnzb _fadeloop

	; Wait for any key press
	mov a, 0
_waitkeysloop:
	halt
	mov a, [n+KEY_PAD]
	cmp a, $FF
	jzb _waitkeysloop

	; Fade out
	mov a, $20
_fadeoutloop:
	push a
	cint CINT_TMP_CONTRAST
	pop a
	halt
	dec a
	jnzb _fadeoutloop

	; Shutdown
	cint CINT_SHUTDOWN

	.align 8
teampokeme:
	.incbin "teampokeme.bin"

	ROMEND
