; Copyright (C) 2012 by JustBurn
;
; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:
;
; The above copyright notice and this permission notice shall be included in
; all copies or substantial portions of the Software.
;
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
; THE SOFTWARE.

; Reg   Inside Func    After Any Call  Description
;-------------------------------------------------
;  BA = Undefined      Result          Result
;  HL = Undefined      Saved           Saved
;   X = Undefined      Destroyed       Unused
;   Y = Base           Saved           Base Address
;   I = Undefined      Destroyed       Unused
;  XI = Undefined      Destroyed       Unused
;  YI = !Must be 0!    Value 0         Base Index

.ifndef __PMASP__
 .printf "CStyle requires PMAS+\n"
.endif

.ifdef PM_MULTIPASS
 .option multipass PM_MULTIPASS
.else
 .option multipass 4
.endif

.define PM_CSTYLE

.set CSTYLE_POFF	5	; Y+CSTYLE_POFF+param
.set CSTYLE_LOFF	-2	; Y+CSTYLE_LOFF-local

.seticase ENDF_BYTE		1
.seticase ENDF_RESTORE_YI	2
.seticase ENDF_HL_STACK		4

.seticase PTR_1 	0x0001
.seticase PTR_2 	0x0002
.seticase PTR_3 	0x0004
.seticase PTR_4 	0x0008
.seticase PTR_5 	0x0010
.seticase PTR_6 	0x0020
.seticase PTR_7 	0x0040
.seticase PTR_8 	0x0080
.seticase PTR_9 	0x0100
.seticase PTR_10	0x0200
.seticase PTR_11	0x0400
.seticase PTR_12	0x0800
.seticase PTR_13	0x1000
.seticase PTR_14	0x2000
.seticase PTR_15	0x4000
.seticase PTR_16	0x8000

.seticase FAR_OF	0x40000000
.seticase NEAR_OF	0x20000000
.seticase RAM_OF	0x10000000
.seticase LOCAL_OF	0x08000000

.seticase REG_BA	0x01000000
.seticase REG_HL	0x01000001
.seticase REG_X 	0x01000002
.seticase REG_Y_DESTROY	0x01000003
.seticase REG_A 	0x01000004
.seticase REG_B 	0x01000005
.seticase REG_L 	0x01000006
.seticase REG_H 	0x01000007
.seticase REG_UA	0x01000008
.seticase REG_UB	0x01000009
.seticase REG_UL	0x0100000A
.seticase REG_UH	0x0100000B

.seticase PTR_ZBA	0x01000020
.seticase PTR_ZHL	0x01000021
.seticase PTR_ZX	0x01000022
.seticase PTR_ZY	0x01000023
.seticase PTR_FBA	0x01000024
.seticase PTR_FHL	0x01000025
.seticase PTR_FX	0x01000026
.seticase PTR_FY	0x01000027
.seticase PTR_LBA	0x01000028
.seticase PTR_AHL	0x01000029
.seticase PTR_AX	0x0100002A
.seticase PTR_AY	0x0100002B
.seticase PTR_HBA	0x0100002C
.seticase PTR_BHL	0x0100002D
.seticase PTR_BX	0x0100002E
.seticase PTR_BY	0x0100002F
.seticase PTR_LX	0x01000030
.seticase PTR_LY	0x01000031
.seticase PTR_HX	0x01000032
.seticase PTR_HY	0x01000033

.macroicase cinvokeparam typ, par
 .if (typ != 0)
	; CPtr type
  .ifstring par
	jmpb _c_end
_s_start:
   .db par, 0
_c_end:
	mov h, 0
	mov l, _s_start >> 16
	push hl
	mov hl, _s_start & 0xFFFF
	push hl
  .elif (par >= 0) && (par < 2097151)
	mov hl, par >> 16
	push hl
	mov hl, par & 0xFFFF
	push hl
  .elif (par == PTR_ZBA)
	mov hl, 0
	push hl
	push ba
  .elif (par == PTR_ZHL)
	mov hl, 0
	push hl
	mov hl, [sp+cinvoke_stmp+2]
	push hl
  .elif (par == PTR_ZX)
	mov hl, 0
	push hl
	push x
  .elif (par == PTR_ZY)
	mov hl, 0
	push hl
	push y
  .elif (par == PTR_FBA)
	xchg ba, hl
	mov a, i
	mov b, 0
	push ba
	xchg ba, hl
	push ba
  .elif (par == PTR_FHL)
	xchg ba, hl
	mov a, i
	mov b, 0
	push ba
	xchg ba, hl
	mov hl, [sp+cinvoke_stmp+2]
	push hl
  .elif (par == PTR_FX)
	xchg ba, hl
	mov a, xi
	mov b, 0
	push ba
	xchg ba, hl
	push x
  .elif (par == PTR_FY)
	xchg ba, hl
	mov a, yi
	mov b, 0
	push ba
	xchg ba, hl
	push y
  .elif (par == PTR_LBA)
	mov hl, [sp+cinvoke_stmp]
	mov h, 0
	push hl
	push ba
  .elif (par == PTR_AHL)
	mov l, 0
	push l
	push a
	push hl
  .elif (par == PTR_AX)
	mov l, 0
	push l
	push a
	push x
  .elif (par == PTR_AY)
	mov l, 0
	push l
	push a
	push y
  .elif (par == PTR_HBA)
	mov hl, [sp+cinvoke_stmp]
	mov l, h
	mov h, 0
	push hl
	push ba
  .elif (par == PTR_BHL)
	mov l, 0
	push l
	push b
	push hl
  .elif (par == PTR_BX)
	mov l, 0
	push l
	push b
	push x
  .elif (par == PTR_BY)
	mov l, 0
	push l
	push b
	push y
  .elif (par == PTR_LX)
	mov hl, [sp+cinvoke_stmp]
	mov h, 0
	push hl
	push x
  .elif (par == PTR_LY)
	mov hl, [sp+cinvoke_stmp]
	mov h, 0
	push hl
	push y
  .elif (par == PTR_HX)
	mov hl, [sp+cinvoke_stmp+1]
	mov h, 0
	push hl
	push x
  .elif (par == PTR_HY)
	mov hl, [sp+cinvoke_stmp+1]
	mov h, 0
	push hl
	push y
  .elif (par & LOCAL_OF)
	mov l, [y+(CSTYLE_LOFF-2-par)]
	mov h, 0
	push hl
	mov l, [y+(CSTYLE_LOFF+0-par)]
	mov h, [y+(CSTYLE_LOFF+1-par)]
	push hl
  .elif (par & RAM_OF)
	mov l, [(par+2) & 0xFFFF]
	mov h, 0
	push hl
	mov l, [par & 0xFFFF]
	mov h, [(par+1) & 0xFFFF]
	push hl
  .elif (par & NEAR_OF)
	mov hl, [(par+2) & 0xFFFF]
	mov h, 0
	push hl
	mov hl, [par & 0xFFFF]
	push hl
  .elif (par & FAR_OF)
	push i
	mov i, ((par+2) & 0xFF0000) >> 16
	mov hl, [(par+2) & 0xFFFF]
	mov h, 0
	pop i
	push hl
	push i
	mov i, (par & 0xFF0000) >> 16
	mov hl, [par & 0xFFFF]
	pop i
	push hl
  .else
   .error "Invalid CPtr"
  .endif
  .set cinvoke_stmp (cinvoke_stmp+4)
 .else
	; CVar type
  .if (par >= -32768) && (par < 65536)
	mov hl, par & 0xFFFF
	push hl
  .elif (par == REG_BA)
	push ba
  .elif (par == REG_HL)
	mov hl, [sp+cinvoke_stmp]
	push hl
  .elif (par == REG_X)
	push x
  .elif (par == REG_Y_DESTROY)
	push y
  .elif (par == REG_A)
	mov l, 0
	push l
	push a
  .elif (par == REG_B)
	mov l, 0
	push l
	push b
  .elif (par == REG_L)
	mov hl, [sp+cinvoke_stmp]
	mov h, 0
	push hl
  .elif (par == REG_H)
	mov hl, [sp+cinvoke_stmp+1]
	mov h, 0
	push hl
  .elif (par == REG_UA)
	push a
	mov l, 0
	push l
  .elif (par == REG_UB)
	push b
	mov l, 0
	push l
  .elif (par == REG_UL)
	mov hl, [sp+cinvoke_stmp-1]
	mov l, 0
	push hl
  .elif (par == REG_UH)
	mov hl, [sp+cinvoke_stmp]
	mov l, 0
	push hl
  .elif (par & LOCAL_OF)
	mov l, [y+(CSTYLE_LOFF+0-par)]
	mov h, [y+(CSTYLE_LOFF+1-par)]
	push hl
  .elif (par & RAM_OF)
	mov l, [par & 0xFFFF]
	mov h, [(par+1) & 0xFFFF]
	push hl
  .elif (par & NEAR_OF)
	mov hl, [par & 0xFFFF]
	push hl
  .elif (par & FAR_OF)
 	push i
	mov i, (par & 0xFF0000) >> 16
	mov hl, [par & 0xFFFF]
	pop i
	push hl
  .else
   .error "Invalid CVar"
  .endif
  .set cinvoke_stmp (cinvoke_stmp+2)
 .endif
.endm

.macroicase cinvoke16 $func, par1, par2, par3, par4, par5, par6, par7, par8, par9, par10, par11, par12, par13, par14, par15, par16
 .parse	".define " + func + "_cinvoked"
 .parse ".set cinvoke_ttmp " + func + "_cstyle_prtype"
 .set cinvoke_stmp 0
 	push hl
	cinvokeparam cinvoke_ttmp & PTR_16, par16
	cinvokeparam cinvoke_ttmp & PTR_15, par15
	cinvokeparam cinvoke_ttmp & PTR_14, par14
	cinvokeparam cinvoke_ttmp & PTR_13, par13
	cinvokeparam cinvoke_ttmp & PTR_12, par12
	cinvokeparam cinvoke_ttmp & PTR_11, par11
	cinvokeparam cinvoke_ttmp & PTR_10, par10
	cinvokeparam cinvoke_ttmp & PTR_9, par9
	cinvokeparam cinvoke_ttmp & PTR_8, par8
	cinvokeparam cinvoke_ttmp & PTR_7, par7
	cinvokeparam cinvoke_ttmp & PTR_6, par6
	cinvokeparam cinvoke_ttmp & PTR_5, par5
	cinvokeparam cinvoke_ttmp & PTR_4, par4
	cinvokeparam cinvoke_ttmp & PTR_3, par3
	cinvokeparam cinvoke_ttmp & PTR_2, par2
	cinvokeparam cinvoke_ttmp & PTR_1, par1
 .parse	" fcall " + func + "_cstyle"
	add sp, hl
	pop hl
 .unset cinvoke_stmp
 .unset cinvoke_ttmp
.endm

.macroicase cinvoke15 $func, par1, par2, par3, par4, par5, par6, par7, par8, par9, par10, par11, par12, par13, par14, par15
 .parse	".define " + func + "_cinvoked"
 .parse ".set cinvoke_ttmp " + func + "_cstyle_prtype"
 .set cinvoke_stmp 0
 	push hl
	cinvokeparam cinvoke_ttmp & PTR_15, par15
	cinvokeparam cinvoke_ttmp & PTR_14, par14
	cinvokeparam cinvoke_ttmp & PTR_13, par13
	cinvokeparam cinvoke_ttmp & PTR_12, par12
	cinvokeparam cinvoke_ttmp & PTR_11, par11
	cinvokeparam cinvoke_ttmp & PTR_10, par10
	cinvokeparam cinvoke_ttmp & PTR_9, par9
	cinvokeparam cinvoke_ttmp & PTR_8, par8
	cinvokeparam cinvoke_ttmp & PTR_7, par7
	cinvokeparam cinvoke_ttmp & PTR_6, par6
	cinvokeparam cinvoke_ttmp & PTR_5, par5
	cinvokeparam cinvoke_ttmp & PTR_4, par4
	cinvokeparam cinvoke_ttmp & PTR_3, par3
	cinvokeparam cinvoke_ttmp & PTR_2, par2
	cinvokeparam cinvoke_ttmp & PTR_1, par1
 .parse	" fcall " + func + "_cstyle"
	add sp, hl
	pop hl
 .unset cinvoke_stmp
 .unset cinvoke_ttmp
.endm

.macroicase cinvoke14 $func, par1, par2, par3, par4, par5, par6, par7, par8, par9, par10, par11, par12, par13, par14
 .parse	".define " + func + "_cinvoked"
 .parse ".set cinvoke_ttmp " + func + "_cstyle_prtype"
 .set cinvoke_stmp 0
	push hl
	cinvokeparam cinvoke_ttmp & PTR_14, par14
	cinvokeparam cinvoke_ttmp & PTR_13, par13
	cinvokeparam cinvoke_ttmp & PTR_12, par12
	cinvokeparam cinvoke_ttmp & PTR_11, par11
	cinvokeparam cinvoke_ttmp & PTR_10, par10
	cinvokeparam cinvoke_ttmp & PTR_9, par9
	cinvokeparam cinvoke_ttmp & PTR_8, par8
	cinvokeparam cinvoke_ttmp & PTR_7, par7
	cinvokeparam cinvoke_ttmp & PTR_6, par6
	cinvokeparam cinvoke_ttmp & PTR_5, par5
	cinvokeparam cinvoke_ttmp & PTR_4, par4
	cinvokeparam cinvoke_ttmp & PTR_3, par3
	cinvokeparam cinvoke_ttmp & PTR_2, par2
	cinvokeparam cinvoke_ttmp & PTR_1, par1
 .parse	" fcall " + func + "_cstyle"
	add sp, hl
	pop hl
 .unset cinvoke_stmp
 .unset cinvoke_ttmp
.endm

.macroicase cinvoke13 $func, par1, par2, par3, par4, par5, par6, par7, par8, par9, par10, par11, par12, par13
 .parse	".define " + func + "_cinvoked"
 .parse ".set cinvoke_ttmp " + func + "_cstyle_prtype"
 .set cinvoke_stmp 0
	push hl
	cinvokeparam cinvoke_ttmp & PTR_13, par13
	cinvokeparam cinvoke_ttmp & PTR_12, par12
	cinvokeparam cinvoke_ttmp & PTR_11, par11
	cinvokeparam cinvoke_ttmp & PTR_10, par10
	cinvokeparam cinvoke_ttmp & PTR_9, par9
	cinvokeparam cinvoke_ttmp & PTR_8, par8
	cinvokeparam cinvoke_ttmp & PTR_7, par7
	cinvokeparam cinvoke_ttmp & PTR_6, par6
	cinvokeparam cinvoke_ttmp & PTR_5, par5
	cinvokeparam cinvoke_ttmp & PTR_4, par4
	cinvokeparam cinvoke_ttmp & PTR_3, par3
	cinvokeparam cinvoke_ttmp & PTR_2, par2
	cinvokeparam cinvoke_ttmp & PTR_1, par1
 .parse	" fcall " + func + "_cstyle"
	add sp, hl
	pop hl
 .unset cinvoke_stmp
 .unset cinvoke_ttmp
.endm

.macroicase cinvoke12 $func, par1, par2, par3, par4, par5, par6, par7, par8, par9, par10, par11, par12
 .parse	".define " + func + "_cinvoked"
 .parse ".set cinvoke_ttmp " + func + "_cstyle_prtype"
 .set cinvoke_stmp 0
	push hl
	cinvokeparam cinvoke_ttmp & PTR_12, par12
	cinvokeparam cinvoke_ttmp & PTR_11, par11
	cinvokeparam cinvoke_ttmp & PTR_10, par10
	cinvokeparam cinvoke_ttmp & PTR_9, par9
	cinvokeparam cinvoke_ttmp & PTR_8, par8
	cinvokeparam cinvoke_ttmp & PTR_7, par7
	cinvokeparam cinvoke_ttmp & PTR_6, par6
	cinvokeparam cinvoke_ttmp & PTR_5, par5
	cinvokeparam cinvoke_ttmp & PTR_4, par4
	cinvokeparam cinvoke_ttmp & PTR_3, par3
	cinvokeparam cinvoke_ttmp & PTR_2, par2
	cinvokeparam cinvoke_ttmp & PTR_1, par1
 .parse	" fcall " + func + "_cstyle"
	add sp, hl
	pop hl
 .unset cinvoke_stmp
 .unset cinvoke_ttmp
.endm

.macroicase cinvoke11 $func, par1, par2, par3, par4, par5, par6, par7, par8, par9, par10, par11
 .parse	".define " + func + "_cinvoked"
 .parse ".set cinvoke_ttmp " + func + "_cstyle_prtype"
 .set cinvoke_stmp 0
	push hl
	cinvokeparam cinvoke_ttmp & PTR_11, par11
	cinvokeparam cinvoke_ttmp & PTR_10, par10
	cinvokeparam cinvoke_ttmp & PTR_9, par9
	cinvokeparam cinvoke_ttmp & PTR_8, par8
	cinvokeparam cinvoke_ttmp & PTR_7, par7
	cinvokeparam cinvoke_ttmp & PTR_6, par6
	cinvokeparam cinvoke_ttmp & PTR_5, par5
	cinvokeparam cinvoke_ttmp & PTR_4, par4
	cinvokeparam cinvoke_ttmp & PTR_3, par3
	cinvokeparam cinvoke_ttmp & PTR_2, par2
	cinvokeparam cinvoke_ttmp & PTR_1, par1
 .parse	" fcall " + func + "_cstyle"
	add sp, hl
	pop hl
 .unset cinvoke_stmp
 .unset cinvoke_ttmp
.endm

.macroicase cinvoke10 $func, par1, par2, par3, par4, par5, par6, par7, par8, par9, par10
 .parse	".define " + func + "_cinvoked"
 .parse ".set cinvoke_ttmp " + func + "_cstyle_prtype"
 .set cinvoke_stmp 0
	push hl
	cinvokeparam cinvoke_ttmp & PTR_10, par10
	cinvokeparam cinvoke_ttmp & PTR_9, par9
	cinvokeparam cinvoke_ttmp & PTR_8, par8
	cinvokeparam cinvoke_ttmp & PTR_7, par7
	cinvokeparam cinvoke_ttmp & PTR_6, par6
	cinvokeparam cinvoke_ttmp & PTR_5, par5
	cinvokeparam cinvoke_ttmp & PTR_4, par4
	cinvokeparam cinvoke_ttmp & PTR_3, par3
	cinvokeparam cinvoke_ttmp & PTR_2, par2
	cinvokeparam cinvoke_ttmp & PTR_1, par1
 .parse	" fcall " + func + "_cstyle"
	add sp, hl
	pop hl
 .unset cinvoke_stmp
 .unset cinvoke_ttmp
.endm

.macroicase cinvoke9 $func, par1, par2, par3, par4, par5, par6, par7, par8, par9
 .parse	".define " + func + "_cinvoked"
 .parse ".set cinvoke_ttmp " + func + "_cstyle_prtype"
 .set cinvoke_stmp 0
	push hl
	cinvokeparam cinvoke_ttmp & PTR_9, par9
	cinvokeparam cinvoke_ttmp & PTR_8, par8
	cinvokeparam cinvoke_ttmp & PTR_7, par7
	cinvokeparam cinvoke_ttmp & PTR_6, par6
	cinvokeparam cinvoke_ttmp & PTR_5, par5
	cinvokeparam cinvoke_ttmp & PTR_4, par4
	cinvokeparam cinvoke_ttmp & PTR_3, par3
	cinvokeparam cinvoke_ttmp & PTR_2, par2
	cinvokeparam cinvoke_ttmp & PTR_1, par1
 .parse	" fcall " + func + "_cstyle"
	add sp, hl
	pop hl
 .unset cinvoke_stmp
 .unset cinvoke_ttmp
.endm

.macroicase cinvoke8 $func, par1, par2, par3, par4, par5, par6, par7, par8
 .parse	".define " + func + "_cinvoked"
 .parse ".set cinvoke_ttmp " + func + "_cstyle_prtype"
 .set cinvoke_stmp 0
	push hl
	cinvokeparam cinvoke_ttmp & PTR_8, par8
	cinvokeparam cinvoke_ttmp & PTR_7, par7
	cinvokeparam cinvoke_ttmp & PTR_6, par6
	cinvokeparam cinvoke_ttmp & PTR_5, par5
	cinvokeparam cinvoke_ttmp & PTR_4, par4
	cinvokeparam cinvoke_ttmp & PTR_3, par3
	cinvokeparam cinvoke_ttmp & PTR_2, par2
	cinvokeparam cinvoke_ttmp & PTR_1, par1
 .parse	" fcall " + func + "_cstyle"
	add sp, hl
	pop hl
 .unset cinvoke_stmp
 .unset cinvoke_ttmp
.endm

.macroicase cinvoke7 $func, par1, par2, par3, par4, par5, par6, par7
 .parse	".define " + func + "_cinvoked"
 .parse ".set cinvoke_ttmp " + func + "_cstyle_prtype"
 .set cinvoke_stmp 0
	push hl
	cinvokeparam cinvoke_ttmp & PTR_7, par7
	cinvokeparam cinvoke_ttmp & PTR_6, par6
	cinvokeparam cinvoke_ttmp & PTR_5, par5
	cinvokeparam cinvoke_ttmp & PTR_4, par4
	cinvokeparam cinvoke_ttmp & PTR_3, par3
	cinvokeparam cinvoke_ttmp & PTR_2, par2
	cinvokeparam cinvoke_ttmp & PTR_1, par1
 .parse	" fcall " + func + "_cstyle"
	add sp, hl
	pop hl
 .unset cinvoke_stmp
 .unset cinvoke_ttmp
.endm

.macroicase cinvoke6 $func, par1, par2, par3, par4, par5, par6
 .parse	".define " + func + "_cinvoked"
 .parse ".set cinvoke_ttmp " + func + "_cstyle_prtype"
 .set cinvoke_stmp 0
	push hl
	cinvokeparam cinvoke_ttmp & PTR_6, par6
	cinvokeparam cinvoke_ttmp & PTR_5, par5
	cinvokeparam cinvoke_ttmp & PTR_4, par4
	cinvokeparam cinvoke_ttmp & PTR_3, par3
	cinvokeparam cinvoke_ttmp & PTR_2, par2
	cinvokeparam cinvoke_ttmp & PTR_1, par1
 .parse	" fcall " + func + "_cstyle"
	add sp, hl
	pop hl
 .unset cinvoke_stmp
 .unset cinvoke_ttmp
.endm

.macroicase cinvoke5 $func, par1, par2, par3, par4, par5
 .parse	".define " + func + "_cinvoked"
 .parse ".set cinvoke_ttmp " + func + "_cstyle_prtype"
 .set cinvoke_stmp 0
	push hl
	cinvokeparam cinvoke_ttmp & PTR_5, par5
	cinvokeparam cinvoke_ttmp & PTR_4, par4
	cinvokeparam cinvoke_ttmp & PTR_3, par3
	cinvokeparam cinvoke_ttmp & PTR_2, par2
	cinvokeparam cinvoke_ttmp & PTR_1, par1
 .parse	" fcall " + func + "_cstyle"
	add sp, hl
	pop hl
 .unset cinvoke_stmp
 .unset cinvoke_ttmp
.endm

.macroicase cinvoke4 $func, par1, par2, par3, par4
 .parse	".define " + func + "_cinvoked"
 .parse ".set cinvoke_ttmp " + func + "_cstyle_prtype"
 .set cinvoke_stmp 0
	push hl
	cinvokeparam cinvoke_ttmp & PTR_4, par4
	cinvokeparam cinvoke_ttmp & PTR_3, par3
	cinvokeparam cinvoke_ttmp & PTR_2, par2
	cinvokeparam cinvoke_ttmp & PTR_1, par1
 .parse	" fcall " + func + "_cstyle"
	add sp, hl
	pop hl
 .unset cinvoke_stmp
 .unset cinvoke_ttmp
.endm

.macroicase cinvoke3 $func, par1, par2, par3
 .parse	".define " + func + "_cinvoked"
 .parse ".set cinvoke_ttmp " + func + "_cstyle_prtype"
 .set cinvoke_stmp 0
	push hl
	cinvokeparam cinvoke_ttmp & PTR_3, par3
	cinvokeparam cinvoke_ttmp & PTR_2, par2
	cinvokeparam cinvoke_ttmp & PTR_1, par1
 .parse	" fcall " + func + "_cstyle"
	add sp, hl
	pop hl
 .unset cinvoke_stmp
 .unset cinvoke_ttmp
.endm

.macroicase cinvoke2 $func, par1, par2
 .parse	".define " + func + "_cinvoked"
 .parse ".set cinvoke_ttmp " + func + "_cstyle_prtype"
 .set cinvoke_stmp 0
	push hl
	cinvokeparam cinvoke_ttmp & PTR_2, par2
	cinvokeparam cinvoke_ttmp & PTR_1, par1
 .parse	" fcall " + func + "_cstyle"
	add sp, hl
	pop hl
 .unset cinvoke_stmp
 .unset cinvoke_ttmp
.endm

.macroicase cinvoke1 $func, par1
 .parse	".define " + func + "_cinvoked"
 .parse ".set cinvoke_ttmp " + func + "_cstyle_prtype"
 .set cinvoke_stmp 0
	push hl
	cinvokeparam cinvoke_ttmp & PTR_1, par1
 .parse	" fcall " + func + "_cstyle"
	add sp, hl
	pop hl
 .unset cinvoke_stmp
 .unset cinvoke_ttmp
.endm

.macroicase cinvoke0 $func
 .parse	".define " + func + "_cinvoked"
	push hl
 .parse	" fcall " + func + "_cstyle"
 	pop hl
.endm

.macroicase getparam_iba param, par
 .if (par >= -32768) && (par < 65536)
  .error "getparam destination cannot be immediate"
 .elif (par == REG_BA)
	mov a, [y+(CSTYLE_POFF+0+param*2)]
	mov b, [y+(CSTYLE_POFF+1+param*2)]
 .elif (par == REG_HL)
	mov l, [y+(CSTYLE_POFF+0+param*2)]
	mov h, [y+(CSTYLE_POFF+1+param*2)]
 .elif (par == REG_X)
	mov a, [y+(CSTYLE_POFF+0+param*2)]
	mov b, [y+(CSTYLE_POFF+1+param*2)]
	mov x, ba
 .elif (par == REG_Y_DESTROY)
	mov a, [y+(CSTYLE_POFF+0+param*2)]
	mov b, [y+(CSTYLE_POFF+1+param*2)]
	mov y, ba
 .elif (par == REG_A)
	mov a, [y+(CSTYLE_POFF+0+param*2)]
 .elif (par == REG_B)
	mov b, [y+(CSTYLE_POFF+0+param*2)]
 .elif (par == REG_L)
	mov l, [y+(CSTYLE_POFF+0+param*2)]
 .elif (par == REG_H)
	mov h, [y+(CSTYLE_POFF+0+param*2)]
 .elif (par == REG_UA)
	mov a, [y+(CSTYLE_POFF+1+param*2)]
 .elif (par == REG_UB)
	mov b, [y+(CSTYLE_POFF+1+param*2)]
 .elif (par == REG_UL)
	mov l, [y+(CSTYLE_POFF+1+param*2)]
 .elif (par == REG_UH)
	mov h, [y+(CSTYLE_POFF+1+param*2)]
 .elif (par & LOCAL_OF)
	mov a, [y+(CSTYLE_POFF+0+param*2)]
	mov b, [y+(CSTYLE_POFF+1+param*2)]
	mov [y+(CSTYLE_LOFF+0-par)], a
	mov [y+(CSTYLE_LOFF+1-par)], b
 .elif (par & RAM_OF)
	mov a, [y+(CSTYLE_POFF+0+param*2)]
	mov b, [y+(CSTYLE_POFF+1+param*2)]
	mov [par & 0xFFFF], a
	mov [(par+1) & 0xFFFF], b
 .elif (par & NEAR_OF)
	mov a, [y+(CSTYLE_POFF+0+param*2)]
	mov b, [y+(CSTYLE_POFF+1+param*2)]
	mov [par & 0xFFFF], ba
 .elif (par & FAR_OF)
	mov a, [y+(CSTYLE_POFF+0+param*2)]
	mov b, [y+(CSTYLE_POFF+1+param*2)]
	mov i, (par & 0xFF0000) >> 16
	mov [par & 0xFFFF], ba
 .else
  .error "Invalid CVar"
 .endif
.endm

.macroicase getparam_ihl param, par
 .if (par >= -32768) && (par < 65536)
  .error "getparam destination cannot be immediate"
 .elif (par == REG_BA)
	mov a, [y+(CSTYLE_POFF+0+param*2)]
	mov b, [y+(CSTYLE_POFF+1+param*2)]
 .elif (par == REG_HL)
	mov l, [y+(CSTYLE_POFF+0+param*2)]
	mov h, [y+(CSTYLE_POFF+1+param*2)]
 .elif (par == REG_X)
	mov l, [y+(CSTYLE_POFF+0+param*2)]
	mov h, [y+(CSTYLE_POFF+1+param*2)]
	mov x, hl
 .elif (par == REG_Y_DESTROY)
	mov l, [y+(CSTYLE_POFF+0+param*2)]
	mov h, [y+(CSTYLE_POFF+1+param*2)]
	mov y, hl
 .elif (par == REG_A)
	mov a, [y+(CSTYLE_POFF+0+param*2)]
 .elif (par == REG_B)
	mov b, [y+(CSTYLE_POFF+0+param*2)]
 .elif (par == REG_L)
	mov l, [y+(CSTYLE_POFF+0+param*2)]
 .elif (par == REG_H)
	mov h, [y+(CSTYLE_POFF+0+param*2)]
 .elif (par == REG_UA)
	mov a, [y+(CSTYLE_POFF+1+param*2)]
 .elif (par == REG_UB)
	mov b, [y+(CSTYLE_POFF+1+param*2)]
 .elif (par == REG_UL)
	mov l, [y+(CSTYLE_POFF+1+param*2)]
 .elif (par == REG_UH)
	mov h, [y+(CSTYLE_POFF+1+param*2)]
 .elif (par & LOCAL_OF)
	mov l, [y+(CSTYLE_POFF+0+param*2)]
	mov h, [y+(CSTYLE_POFF+1+param*2)]
	mov [y+(CSTYLE_LOFF+0-par)], l
	mov [y+(CSTYLE_LOFF+1-par)], h
 .elif (par & RAM_OF)
	mov l, [y+(CSTYLE_POFF+0+param*2)]
	mov h, [y+(CSTYLE_POFF+1+param*2)]
	mov [par & 0xFFFF], l
	mov [(par+1) & 0xFFFF], h
 .elif (par & NEAR_OF)
	mov l, [y+(CSTYLE_POFF+0+param*2)]
	mov h, [y+(CSTYLE_POFF+1+param*2)]
	mov [par & 0xFFFF], hl
 .elif (par & FAR_OF)
	mov l, [y+(CSTYLE_POFF+0+param*2)]
	mov h, [y+(CSTYLE_POFF+1+param*2)]
	mov i, (par & 0xFF0000) >> 16
	mov [par & 0xFFFF], hl
 .else
  .error "Invalid CVar"
 .endif
.endm

.macroicase getparam param, par
 .if (par >= -32768) && (par < 65536)
  .error "getparam destination cannot be immediate"
 .elif (par == REG_BA)
	mov a, [y+(CSTYLE_POFF+0+param*2)]
	mov b, [y+(CSTYLE_POFF+1+param*2)]
 .elif (par == REG_HL)
	mov l, [y+(CSTYLE_POFF+0+param*2)]
	mov h, [y+(CSTYLE_POFF+1+param*2)]
 .elif (par == REG_X)
	xchg ba, x
	mov a, [y+(CSTYLE_POFF+0+param*2)]
	mov b, [y+(CSTYLE_POFF+1+param*2)]
	xchg ba, x
 .elif (par == REG_Y_DESTROY)
	push hl
	mov l, [y+(CSTYLE_POFF+0+param*2)]
	mov h, [y+(CSTYLE_POFF+1+param*2)]
	mov y, hl
	pop hl
 .elif (par == REG_A)
	mov a, [y+(CSTYLE_POFF+0+param*2)]
 .elif (par == REG_B)
	mov b, [y+(CSTYLE_POFF+0+param*2)]
 .elif (par == REG_L)
	mov l, [y+(CSTYLE_POFF+0+param*2)]
 .elif (par == REG_H)
	mov h, [y+(CSTYLE_POFF+0+param*2)]
 .elif (par == REG_UA)
	mov a, [y+(CSTYLE_POFF+1+param*2)]
 .elif (par == REG_UB)
	mov b, [y+(CSTYLE_POFF+1+param*2)]
 .elif (par == REG_UL)
	mov l, [y+(CSTYLE_POFF+1+param*2)]
 .elif (par == REG_UH)
	mov h, [y+(CSTYLE_POFF+1+param*2)]
 .elif (par & LOCAL_OF)
	push a
	mov a, [y+(CSTYLE_POFF+0+param*2)]
	mov [y+(CSTYLE_LOFF+0-par)], a
	mov a, [y+(CSTYLE_POFF+1+param*2)]
	mov [y+(CSTYLE_LOFF+1-par)], a
	pop a
 .elif (par & RAM_OF)
	push ba
	mov a, [y+(CSTYLE_POFF+0+param*2)]
	mov b, [y+(CSTYLE_POFF+1+param*2)]
	mov [par & 0xFFFF], a
	mov [(par+1) & 0xFFFF], b
	pop ba
 .elif (par & NEAR_OF)
	push ba
	mov a, [y+(CSTYLE_POFF+0+param*2)]
	mov b, [y+(CSTYLE_POFF+1+param*2)]
	mov [par & 0xFFFF], ba
	pop ba
 .elif (par & FAR_OF)
	push i
	push ba
	mov a, [y+(CSTYLE_POFF+0+param*2)]
	mov b, [y+(CSTYLE_POFF+1+param*2)]
	mov i, (par & 0xFF0000) >> 16
	mov [par & 0xFFFF], ba
	pop ba
	pop i
 .else
  .error "Invalid CVar"
 .endif
.endm

.macroicase setparam param, par
 .if (par >= -32768) && (par < 65536)
	push ba
	mov ba, par & 0xFFFF
	mov [y+(CSTYLE_POFF+0+param*2)], a
	mov [y+(CSTYLE_POFF+1+param*2)], b
	pop ba
 .elif (par == REG_BA)
	mov [y+(CSTYLE_POFF+0+param*2)], a
	mov [y+(CSTYLE_POFF+1+param*2)], b
 .elif (par == REG_HL)
	mov [y+(CSTYLE_POFF+0+param*2)], l
	mov [y+(CSTYLE_POFF+1+param*2)], h
 .elif (par == REG_X)
	xchg ba, x
	mov [y+(CSTYLE_POFF+0+param*2)], a
	mov [y+(CSTYLE_POFF+1+param*2)], b
	xchg ba, x
 .elif (par == REG_Y_DESTROY)
	push ba
	mov ba, y
	mov [y+(CSTYLE_POFF+0+param*2)], a
	mov [y+(CSTYLE_POFF+1+param*2)], b
	pop ba
 .elif (par == REG_A)
	mov [y+(CSTYLE_POFF+0+param*2)], a
 .elif (par == REG_B)
	mov [y+(CSTYLE_POFF+0+param*2)], b
 .elif (par == REG_L)
	mov [y+(CSTYLE_POFF+0+param*2)], l
 .elif (par == REG_H)
	mov [y+(CSTYLE_POFF+0+param*2)], h
 .elif (par == REG_UA)
	mov [y+(CSTYLE_POFF+1+param*2)], a
 .elif (par == REG_UB)
	mov [y+(CSTYLE_POFF+1+param*2)], b
 .elif (par == REG_UL)
	mov [y+(CSTYLE_POFF+1+param*2)], l
 .elif (par == REG_UH)
	mov [y+(CSTYLE_POFF+1+param*2)], h
 .elif (par & LOCAL_OF)
	push a
	mov a, [y+(CSTYLE_LOFF+0-par)]
	mov [y+(CSTYLE_POFF+0+param*2)], a
	mov a, [y+(CSTYLE_LOFF+1-par)]
	mov [y+(CSTYLE_POFF+1+param*2)], a
	pop a
 .elif (par & RAM_OF)
	push a
	mov a, [par & 0xFFFF]
	mov [y+(CSTYLE_POFF+0+param*2)], a
	mov a, [(par+1) & 0xFFFF]
	mov [y+(CSTYLE_POFF+1+param*2)], a
	pop a
 .elif (par & NEAR_OF)
	push ba
	mov ba, [par & 0xFFFF]
	mov [y+(CSTYLE_POFF+0+param*2)], a
	mov [y+(CSTYLE_POFF+1+param*2)], b
	pop ba
 .elif (par & FAR_OF)
	push i
	push ba
	mov i, (par & 0xFF0000) >> 16
	mov ba, [par & 0xFFFF]
	mov [y+(CSTYLE_POFF+0+param*2)], a
	mov [y+(CSTYLE_POFF+1+param*2)], b
	pop ba
	pop i
 .else
  .error "Invalid CVar"
 .endif
.endm

.macroicase setlocalw local, par
 .if (par >= -32768) && (par < 65536)
	push ba
	mov ba, par & 0xFFFF
	mov [y+(-local-2)], a
	mov [y+(-local-1)], b
	pop ba
 .elif (par == REG_BA)
	mov [y+(-local-2)], a
	mov [y+(-local-1)], b
 .elif (par == REG_HL)
	mov [y+(-local-2)], l
	mov [y+(-local-1)], h
 .elif (par == REG_X)
	xchg ba, x
	mov [y+(-local-2)], a
	mov [y+(-local-1)], b
	xchg ba, x
 .elif (par == REG_Y_DESTROY)
  .error "Can't operate the base when it's already destroyed"
 .elif (par == REG_A)
	mov [y+(-local-2)], a
	push a
	xor a, a
	mov [y+(-local-1)], a
	pop a
 .elif (par == REG_B)
	mov [y+(-local-2)], b
	push a
	xor a, a
	mov [y+(-local-1)], a
	pop a
 .elif (par == REG_L)
	mov [y+(-local-2)], l
	push a
	xor a, a
	mov [y+(-local-1)], a
	pop a
 .elif (par == REG_H)
	mov [y+(-local-2)], h
	push a
	xor a, a
	mov [y+(-local-1)], a
	pop a
 .elif (par == REG_UA)
	push a
	xor a, a
	mov [y+(-local-2)], a
	pop a
	mov [y+(-local-1)], a
 .elif (par == REG_UB)
	push a
	xor a, a
	mov [y+(-local-2)], a
	pop a
	mov [y+(-local-1)], b
 .elif (par == REG_UL)
	push a
	xor a, a
	mov [y+(-local-2)], a
	pop a
	mov [y+(-local-1)], l
 .elif (par == REG_UH)
	push a
	xor a, a
	mov [y+(-local-2)], a
	pop a
	mov [y+(-local-1)], h
 .elif (dest & LOCAL_OF)
	push a
	mov a, [y+(CSTYLE_LOFF+0-par)]
	mov [y+(-local-2)], a
	mov a, [y+(CSTYLE_LOFF+1-par)]
	mov [y+(-local-1)], a
	pop a
 .elif (dest & RAM_OF)
	push a
	mov a, [par & 0xFFFF]
	mov [y+(-local-2)], a
	mov a, [(par+1) & 0xFFFF]
	mov [y+(-local-1)], a
	pop a
 .elif (dest & NEAR_OF)
	push ba
	mov ba, [par & 0xFFFF]
	mov [y+(-local-2)], a
	mov [y+(-local-1)], b
	pop ba
 .elif (dest & FAR_OF)
	push i
	push ba
	mov i, (par & 0xFF0000) >> 16
	mov ba, [par & 0xFFFF]
	mov [y+(-local-2)], a
	mov [y+(-local-1)], b
	pop ba
	pop i
 .else
  .error "Invalid CVar"
 .endif
.endm

.macroicase getlocalw local, par
 .if (par >= -32768) && (par < 65536)
  .error "getlocalw destination cannot be immediate"
 .elif (par == REG_BA)
	mov a, [y+(-local-2)]
	mov b, [y+(-local-1)]
 .elif (par == REG_HL)
	mov l, [y+(-local-2)]
	mov h, [y+(-local-1)]
 .elif (par == REG_X)
	xchg ba, x
	mov a, [y+(-local-2)]
	mov b, [y+(-local-1)]
	xchg ba, x
 .elif (par == REG_Y_DESTROY)
	push ba
	mov a, [y+(-local-2)]
	mov b, [y+(-local-1)]
	mov y, ba
	pop ba
 .elif (par == REG_A)
	mov a, [y+(-local-2)]
 .elif (par == REG_B)
	mov b, [y+(-local-2)]
 .elif (par == REG_L)
	mov l, [y+(-local-2)]
 .elif (par == REG_H)
	mov h, [y+(-local-2)]
 .elif (par == REG_UA)
	mov a, [y+(-local-1)]
 .elif (par == REG_UB)
	mov b, [y+(-local-1)]
 .elif (par == REG_UL)
	mov l, [y+(-local-1)]
 .elif (par == REG_UH)
	mov h, [y+(-local-1)]
 .elif (dest & LOCAL_OF)
	push a
	mov a, [y+(-local-2)]
	mov [y+(CSTYLE_LOFF+0-par)], a
	mov a, [y+(-local-1)]
	mov [y+(CSTYLE_LOFF+1-par)], a
	pop a
 .elif (dest & RAM_OF)
	push a
	mov a, [y+(-local-2)]
	mov [par & 0xFFFF], a
	mov a, [y+(-local-1)]
	mov [(par+1) & 0xFFFF], a
	pop a
 .elif (dest & NEAR_OF)
	push ba
	mov a, [y+(-local-2)]
	mov b, [y+(-local-1)]
	mov [par & 0xFFFF], ba
	pop ba
 .elif (dest & FAR_OF)
 	push i
	push ba
	mov a, [y+(-local-2)]
	mov b, [y+(-local-1)]
	mov i, (par & 0xFF0000) >> 16
	mov [par & 0xFFFF], ba
	pop ba
	pop i
 .else
  .error "Invalid CVar"
 .endif
.endm

.macroicase setlocalb local, par
 .if (par >= -32768) && (par < 65536)
	push a
	mov a, par & 0xFF
	mov [y+(-local-2)], a
	pop a
 .elif (par == REG_BA)
	mov [y+(-local-2)], a
 .elif (par == REG_HL)
	mov [y+(-local-2)], l
 .elif (par == REG_X)
	push ba
	mov ba, x
	mov [y+(-local-2)], a
	pop ba
 .elif (par == REG_Y_DESTROY)
  .error "Can't operate the base when it's already destroyed"
 .elif (par == REG_A)
	mov [y+(-local-2)], a
 .elif (par == REG_B)
	mov [y+(-local-2)], b
 .elif (par == REG_L)
	mov [y+(-local-2)], l
 .elif (par == REG_H)
	mov [y+(-local-2)], h
 .elif (par == REG_UA)
	mov [y+(-local-1)], a
 .elif (par == REG_UB)
	mov [y+(-local-1)], b
 .elif (par == REG_UL)
	mov [y+(-local-1)], l
 .elif (par == REG_UH)
	mov [y+(-local-1)], h
 .elif (dest & LOCAL_OF)
	push a
	mov a, [y+(CSTYLE_LOFF+0-par)]
	mov [y+(-local-2)], a
	pop a
 .elif (dest & RAM_OF)
	push a
	mov a, [par & 0xFFFF]
	mov [y+(-local-2)], a
	pop a
 .elif (dest & NEAR_OF)
	push ba
	mov ba, [par & 0xFFFF]
	mov [y+(-local-2)], a
	pop ba
 .elif (dest & FAR_OF)
	push i
	push ba
	mov i, (par & 0xFF0000) >> 16
	mov ba, [par & 0xFFFF]
	mov [y+(-local-2)], a
	pop ba
	pop i
 .else
  .error "Invalid CVar"
 .endif
.endm

.macroicase getlocalb local, par
 .if (par >= -32768) && (par < 65536)
  .error "getlocalb destination cannot be immediate"
 .elif (par == REG_BA)
	mov a, [y+(-local-2)]
	mov b, 0
 .elif (par == REG_HL)
	mov l, [y+(-local-2)]
	mov h, 0
 .elif (par == REG_X)
	xchg ba, x
	mov l, [y+(-local-2)]
	mov h, 0
	xchg ba, x
 .elif (par == REG_Y_DESTROY)
	push ba
	mov a, [y+(-local-2)]
	mov b, 0
	mov y, ba
	pop ba
 .elif (par == REG_A)
	mov a, [y+(-local-2)]
 .elif (par == REG_B)
	mov b, [y+(-local-2)]
 .elif (par == REG_L)
	mov l, [y+(-local-2)]
 .elif (par == REG_H)
	mov h, [y+(-local-2)]
 .elif (par == REG_UA)
	mov a, [y+(-local-1)]
 .elif (par == REG_UB)
	mov b, [y+(-local-1)]
 .elif (par == REG_UL)
	mov l, [y+(-local-1)]
 .elif (par == REG_UH)
	mov h, [y+(-local-1)]
 .elif (dest & LOCAL_OF)
	push a
	mov a, [y+(-local-2)]
	mov [y+(CSTYLE_LOFF+0-par)], a
	pop a
 .elif (dest & RAM_OF)
	push a
	mov a, [y+(-local-2)]
	mov [par & 0xFFFF], a
	pop a
 .elif (dest & NEAR_OF)
	push a
	push hl
	mov a, [y+(-local-2)]
	mov i, (par & 0xFF0000) >> 16
	mov hl, par & 0xFFFF
	mov [hl], a
	pop hl
	pop a
 .elif (dest & FAR_OF)
	push i
	push a
	push hl
	mov a, [y+(-local-2)]
	mov i, (par & 0xFF0000) >> 16
	mov hl, par & 0xFFFF
	mov [hl], a
	pop hl
	pop a
	pop i
 .else
  .error "Invalid CVar"
 .endif
.endm

.macroicase return_to par
 .if (par >= -32768) && (par < 65536)
  .error "return_to destination cannot be immediate"
 .elif (par == REG_BA)
 .elif (par == REG_HL)
	mov hl, ba
 .elif (par == REG_X)
	mov x, ba
 .elif (par == REG_Y_DESTROY)
	mov y, ba
 .elif (par == REG_A)
 .elif (par == REG_B)
	mov b, a
 .elif (par == REG_L)
	mov l, a
 .elif (par == REG_H)
	mov h, a
 .elif (par == REG_UA)
	mov a, b
 .elif (par == REG_UB)
 .elif (par == REG_UL)
	mov l, b
 .elif (par == REG_UH)
	mov h, b
 .elif (par & LOCAL_OF)
	mov [y+(CSTYLE_LOFF+0-par)], a
	mov [y+(CSTYLE_LOFF+1-par)], b
 .elif (par & RAM_OF)
	mov [par & 0xFFFF], a
	mov [(par+1) & 0xFFFF], b
 .elif (par & NEAR_OF)
	mov [par & 0xFFFF], ba
 .elif (par & FAR_OF)
 	push i
	mov i, (par & 0xFF0000) >> 16
	mov [par & 0xFFFF], ba
	pop i
 .else
  .error "Invalid CVar"
 .endif
.endm

.macroicase declare_function func, prtype, params
 .set cstyle_this_function func
 .parse ".set " + func + "_cstyle_prsize " + (params * 2)
 .parse ".set " + func + "_cstyle_prtype " + prtype
 .set cstyle_this_localsize 0
.endm

.macroicase varlocal $varname, localsize
 .parse ".set " + varname + " " + cstyle_this_localsize
 .set cstyle_this_localsize cstyle_this_localsize + localsize
.endm

.macroicase reservelocal localsize
 .set cstyle_this_localsize cstyle_this_localsize + localsize
.endm

.macroicase begin_function
 .parse cstyle_this_function + "_cstyle:"
	push y
	mov yi, 0
	mov y, sp
 .if (cstyle_this_localsize > 0)
	sub sp, cstyle_this_localsize
 .endif
 .parse ".set cstyle_this_funcaddr " + cstyle_this_function + "_cstyle"
 .parse ".localprefix " + cstyle_this_function + "_cstyle_locals"
.endm

.macroicase return
 .parse ".set cstyle_this_returnaddr " + cstyle_this_function + "_cstyle_return"
 .if (cstyle_this_returnaddr - .) < 127
  .parse " jmpb " + cstyle_this_function + "_cstyle_return"
 .else
  .parse " jmpw " + cstyle_this_function + "_cstyle_return"
 .endif
 .unset cstyle_this_returnaddr
.endm

.macroicase returnc $cond
 .parse ".set cstyle_this_returnaddr " + cstyle_this_function + "_cstyle_return"
 .if (cstyle_this_returnaddr - .) < 127
  .if (cond == "C") || (cond == "c")
   .parse " jcb " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "NC") || (cond == "nc")
   .parse " jncb " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "Z") || (cond == "z")
   .parse " jzb " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "NZ") || (cond == "nz")
   .parse " jnzb " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "L") || (cond == "l")
   .parse " jl " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "LE") || (cond == "le")
   .parse " jle " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "G") || (cond == "g")
   .parse " jg " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "GE") || (cond == "ge")
   .parse " jge " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "O") || (cond == "o")
   .parse " jo " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "NO") || (cond == "no")
   .parse " jno " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "NS") || (cond == "ns")
   .parse " jns " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "S") || (cond == "s")
   .parse " js " + cstyle_this_function + "_cstyle_return"
  .else
   .error "Invalid condition"
  .endif
 .else
  .if (cond == "C") || (cond == "c")
   .parse " jcw " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "NC") || (cond == "nc")
   .parse " jncw " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "Z") || (cond == "z")
   .parse " jzw " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "NZ") || (cond == "nz")
   .parse " jnzw " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "L") || (cond == "l")
   .parse " jge .+7"
   .parse " jmpw " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "LE") || (cond == "le")
   .parse " jg .+7"
   .parse " jmpw " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "G") || (cond == "g")
   .parse " jle .+7"
   .parse " jmpw " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "GE") || (cond == "ge")
   .parse " jl .+7"
   .parse " jmpw " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "O") || (cond == "o")
   .parse " jno .+7"
   .parse " jmpw " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "NO") || (cond == "no")
   .parse " jo .+7"
   .parse " jmpw " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "NS") || (cond == "ns")
   .parse " js .+7"
   .parse " jmpw " + cstyle_this_function + "_cstyle_return"
  .elif (cond == "S") || (cond == "s")
   .parse " jns .+7"
   .parse " jmpw " + cstyle_this_function + "_cstyle_return"
  .else
   .error "Invalid condition"
  .endif
 .endif
 .unset cstyle_this_returnaddr
.endm

.macroicase return_with par
 .if (par >= -32768) && (par < 65536)
	mov ba, par & 0xFFFF
 .elif (par == REG_BA)
 .elif (par == REG_HL)
	mov ba, hl
 .elif (par == REG_X)
	mov ba, x
 .elif (par == REG_Y_DESTROY)
	mov ba, y
 .elif (par == REG_A)
	mov b, 0
 .elif (par == REG_B)
	mov a, b
	mov b, 0
 .elif (par == REG_L)
	mov a, l
	mov b, 0
 .elif (par == REG_H)
	mov a, h
	mov b, 0
 .elif (par == REG_UA)
	mov b, a
	mov a, 0
 .elif (par == REG_UB)
	mov a, 0
 .elif (par == REG_UL)
	xor a, a
	mov b, l
 .elif (par == REG_UH)
	xor a, a
	mov b, h
 .elif (par & LOCAL_OF)
	mov a, [y+(CSTYLE_LOFF+0-par)]
	mov b, [y+(CSTYLE_LOFF+1-par)]
 .elif (par & RAM_OF)
	mov a, [par & 0xFFFF]
	mov b, [(par+1) & 0xFFFF]
 .elif (par & NEAR_OF)
	mov ba, [par & 0xFFFF]
 .elif (par & FAR_OF)
	push i
	mov i, (par & 0xFF0000) >> 16
	mov ba, [par & 0xFFFF]
	pop i
 .else
  .error "Invalid CVar"
 .endif
 .parse ".set cstyle_this_returnaddr " + cstyle_this_function + "_cstyle_return"
 .if (cstyle_this_returnaddr - .) < 127
  .parse " jmpb " + cstyle_this_function + "_cstyle_return"
 .else
  .parse " jmpw " + cstyle_this_function + "_cstyle_return"
 .endif
 .unset cstyle_this_returnaddr
.endm

.macroicase returnc_with $cond, par
 .if (cond == "C") || (cond == "c")
	jncb _notmet
 .elif (cond == "NC") || (cond == "nc")
	jcb _notmet
 .elif (cond == "Z") || (cond == "z")
	jnzb _notmet
 .elif (cond == "NZ") || (cond == "nz")
	jzb _notmet
 .elif (cond == "L") || (cond == "l")
	jge _notmet
 .elif (cond == "LE") || (cond == "le")
	jg _notmet
 .elif (cond == "G") || (cond == "g")
	jle _notmet
 .elif (cond == "GE") || (cond == "ge")
	jl _notmet
 .elif (cond == "O") || (cond == "o")
	jno _notmet
 .elif (cond == "NO") || (cond == "no")
	jo _notmet
 .elif (cond == "NS") || (cond == "ns")
	js _notmet
 .elif (cond == "S") || (cond == "s")
	jns _notmet
 .else
  .error "Invalid condition"
 .endif
 .if (par >= -32768) && (par < 65536)
	mov ba, par & 0xFFFF
 .elif (par == REG_BA)
 .elif (par == REG_HL)
	mov ba, hl
 .elif (par == REG_X)
	mov ba, x
 .elif (par == REG_Y_DESTROY)
	mov ba, y
 .elif (par == REG_A)
	mov b, 0
 .elif (par == REG_B)
	mov a, b
	mov b, 0
 .elif (par == REG_L)
	mov a, l
	mov b, 0
 .elif (par == REG_H)
	mov a, h
	mov b, 0
 .elif (par == REG_UA)
	mov b, a
	mov a, 0
 .elif (par == REG_UB)
	mov a, 0
 .elif (par == REG_UL)
	xor a, a
	mov b, l
 .elif (par == REG_UH)
	xor a, a
	mov b, h
 .elif (par & LOCAL_OF)
	mov a, [y+(CSTYLE_LOFF+0-par)]
	mov b, [y+(CSTYLE_LOFF+1-par)]
 .elif (par & RAM_OF)
	mov a, [par & 0xFFFF]
	mov b, [(par+1) & 0xFFFF]
 .elif (par & NEAR_OF)
	mov ba, [par & 0xFFFF]
 .elif (par & FAR_OF)
	push i
	mov i, (par & 0xFF0000) >> 16
	mov ba, [par & 0xFFFF]
	pop i
 .else
  .error "Invalid CVar"
 .endif
 .parse ".set cstyle_this_returnaddr " + cstyle_this_function + "_cstyle_return"
 .if (cstyle_this_returnaddr - .) < 127
  .parse " jmpb " + cstyle_this_function + "_cstyle_return"
 .else
  .parse " jmpw " + cstyle_this_function + "_cstyle_return"
 .endif
_notmet:
 .unset cstyle_this_returnaddr
.endm

.macroicase end_function flags
 .parse cstyle_this_function + "_cstyle_return:"
 .if (cstyle_this_localsize > 0)
	add sp, cstyle_this_localsize
 .endif
	pop y
 .if (flags & ENDF_BYTE)
	mov b, 0
 .endif
 .if (flags & ENDF_RESTORE_YI)
	mov yi, 0
 .endif
 .if (!(flags & ENDF_HL_STACK))
  .parse " mov hl, " + cstyle_this_function + "_cstyle_prsize"
 .endif
	ret
 .parse cstyle_this_function + "_cstyle_end:"
 .ifdef PM_DEBUG
  .parse ".printf \"Function '%s', %i bytes\n\", \"" + cstyle_this_function + "\", " + cstyle_this_function + "_cstyle_end - " + cstyle_this_function + "_cstyle"
 .endif
 .unset cstyle_this_function
 .unset cstyle_this_funcaddr
 .unset cstyle_this_flags
 .unset cstyle_this_localsize
.endm
