; Copyright (C) 2012 by JustBurn
;
; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:
;
; The above copyright notice and this permission notice shall be included in
; all copies or substantial portions of the Software.
;
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
; THE SOFTWARE.

.ifndef PM_CSTYLE
.error "pm_cstyle.s must be included"
.endif

.if . < 0x2200
.error "pmrom_clcd.s file must be included after pm_header"
.endif


; ] Set constrast
; | c_lcd_contrast
	declare_function "c_lcd_contrast", 0, 1
.ifdef c_lcd_contrast_cinvoked
	begin_function
	getparam 0, REG_A
	mov [n+LCD_CTRL], LCD_CONTRAST
	mov [n+LCD_DATA], a
	end_function 0
.endif
.macro c_lcd_contrast num
	cinvoke1 c_lcd_contrast, num
.endm


; ] Fade screen
; | c_lcd_fade num, time
; *   num    - contrasts, B = Start, A = End
; *   time   - time per tick
	declare_function "c_lcd_fade", 0, 2
.ifdef c_lcd_fade_cinvoked
	begin_function
	getparam 0, REG_BA
	mov [n+LCD_CTRL], LCD_CONTRAST
	mov [n+LCD_DATA], b
	mov h, 0
	mov l, b
	cmp a, b
	jz _start
	jc :f
	inc h
	jmpb _start
:	dec h
	jmpb _start
_start:
	getparam 1, REG_X
	cmp x, 0
	jzb _tick
_loop:
	mov b, 3
:	jdbnz :b
	dec x
	jnzb _loop
_tick:
	xchg ba, hl
	add a, b
	mov [n+LCD_CTRL], LCD_CONTRAST
	mov [n+LCD_DATA], a
	xchg ba, hl
	mov b, l
	cmp a, b
	jnz _start
	end_function 0
.endif
.macro c_lcd_fade num, time
	cinvoke2 c_lcd_fade, num, time
.endm


; ] Fill 1x8 pattern directly to the LCD
; | c_lcd_fill8 range, pattern
	declare_function "c_lcd_fill8", 0, 2
.ifdef c_lcd_fill8_cinvoked
	begin_function
	getparam 0, REG_HL
	getparam 1, REG_A
	inc l
	or l, $B0
:	or h, $B0
	mov [n+LCD_CTRL], h
	mov [n+LCD_CTRL], LCD_COLUMN_LO
	mov [n+LCD_CTRL], LCD_COLUMN_HI
	inc h
	mov b, 24
:	mov [n+LCD_DATA], a
	mov [n+LCD_DATA], a
	mov [n+LCD_DATA], a
	mov [n+LCD_DATA], a
	jdbnz :b
	xchg ba, hl
	cmp a, b
	xchg ba, hl
	jnz :bb
	end_function 0
.endif
.macro c_lcd_fill8 range, pattern
	cinvoke2 c_lcd_fill8, range, pattern
.endm


; ] Fill 2x8 pattern directly to the LCD
; | c_lcd_fill16 range, pattern
	declare_function "c_lcd_fill16", 0, 2
.ifdef c_lcd_fill16_cinvoked
	begin_function
	getparam 0, REG_HL
	inc l
	or l, $B0
:	or h, $B0
	mov [n+LCD_CTRL], h
	mov [n+LCD_CTRL], LCD_COLUMN_LO
	mov [n+LCD_CTRL], LCD_COLUMN_HI
	inc h
	mov b, 48
:	getparam 1, REG_A
	mov [n+LCD_DATA], a
	getparam 1, REG_UA
	mov [n+LCD_DATA], a
	jdbnz :b
	xchg ba, hl
	cmp a, b
	xchg ba, hl
	jnz :bb
	end_function 0
.endif
.macro c_lcd_fill16 range, pattern
	cinvoke2 c_lcd_fill16, range, pattern
.endm


; ] Send raw image directly to the LCD
; | c_lcd_sendraw range, addr
	declare_function "c_lcd_sendraw", PTR_2, 3
.ifdef c_lcd_sendraw_cinvoked
	begin_function
	getparam 2, REG_A
	mov xi, a
	getparam 0, REG_HL
	getparam_iba 1, REG_X
	inc l
	or l, $B0
:	or h, $B0
	mov [n+LCD_CTRL], h
	mov [n+LCD_CTRL], LCD_COLUMN_LO
	mov [n+LCD_CTRL], LCD_COLUMN_HI
	inc h
	mov b, 96
:	mov [n+LCD_DATA], [x]
	inc x
	jdbnz :b
	xchg ba, hl
	cmp a, b
	xchg ba, hl
	jnz :bb
	end_function 0
.endif
.macro c_lcd_sendraw range, addr
	cinvoke2 c_lcd_sendraw, range, addr
.endm
