; Copyright (C) 2012 by JustBurn
;
; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:
;
; The above copyright notice and this permission notice shall be included in
; all copies or substantial portions of the Software.
;
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
; THE SOFTWARE.

.ifndef PM_CSTYLE
.error "pm_cstyle.s must be included"
.endif

.if . < 0x2200
.error "pmrom_cmap8.s file must be included after pm_header"
.endif


; ] Set map
; | c_map8_set width, height, map_addr
; *   width       - Map width in tiles (>= 12 and <= 255)
; *   height      - Map height in tiles (>= 8 and <= 255)
; *   map_addr    - Map address
	declare_function "c_map8_set", PTR_3, 4
.ifdef c_map8_set_cinvoked
	begin_function
	mov i, 0
	getparam 0, REG_A
	mov [pmmap8ram_width], a
	cmp a, 13
	jcb :f
	mov a, 13
:	mov [pmmap8ram_scrwidth], a
	mov b, a
	mov a, [pmmap8ram_width]
	sub a, b
	mov b, 0
	mov [pmmap8ram_screxptc], ba
	getparam 1, REG_A
	mov [pmmap8ram_height], a
	getparam 2, REG_BA
	mov [pmmap8ram_mapaddr], ba
	getparam 3, REG_A
	mov [pmmap8ram_mapaddr+2], a
	mov ba, 0
	mov [map8_camera_x], ba
	mov [map8_camera_y], ba
	end_function 0
.endif
.macro c_map8_set width, height, map_addr
	cinvoke3 c_map8_set, width, height, map_addr
.endm

; ] Draw map
; | c_map8_draw
	declare_function "c_map8_draw", 0, 0
.ifdef c_map8_draw_cinvoked
	begin_function
	mov i, 0
	mov a, [map8_camera_x]
	swap a
	and a, 7
	mov [n+PRC_SCROLL_X], a
	mov a, [map8_camera_y]
	swap a
	and a, 7
	mov [n+PRC_SCROLL_Y], a
	mov a, [pmmap8ram_mapaddr+2]
	mov xi, a
	mov x, [pmmap8ram_mapaddr]
	mov ba, [map8_camera_x]
	add ba, ba
	mov l, b
	mov h, 0
	add x, hl
	mov ba, [map8_camera_y]
	add ba, ba
	mov l, b
	mov a, [pmmap8ram_width]
	mul l, a
	add x, hl
	mov y, MAP_BASE
	mov b, 9
_y:	
	push b
	mov b, [pmmap8ram_scrwidth]
_x:
	mov [y], [x]
	inc x
	jnzb :f
	mov a, xi
	inc a
	mov xi, a
:	inc y
	jdbnz _x
	mov hl, [pmmap8ram_screxptc]
	add x, hl
	jncb :f
	mov a, xi
	inc a
	mov xi, a
:	add y, 16
	mov l, [pmmap8ram_scrwidth]
	sub y, hl
	pop b
	jdbnz _y
	end_function 0
.endif
.macro c_map8_draw
	cinvoke0 c_map8_draw
.endm

; ] Set camera position
; | c_map8_campos x, y
; *   x           - Pixel x-coordinate of camera at left (Fixed 12.4)
; *   y           - Pixel y-coordinate of camera at top (Fixed 12.4)
	declare_function "c_map8_campos", 0, 2
.ifdef c_map8_campos_cinvoked
	begin_function
	mov i, 0
	getparam 0, REG_HL
	mov b, [pmmap8ram_width]
	cmp b, 6
	callcb _zerowidth
	mov a, 0
	sub ba, 12 << 8
	shr b
	cmp hl, ba
	jcb :f
	and h, $80
	mov hl, ba
	jzb :f
	mov hl, 0
:	mov [map8_camera_x], hl
	getparam 1, REG_HL
	mov b, [pmmap8ram_height]
	cmp b, 4
	callcb _zeroheight
	mov a, 0
	sub ba, 8 << 8
	shr b
	cmp hl, ba
	jcb :f
	and h, $80
	mov hl, ba
	jzb :f
	mov hl, 0
:	mov [map8_camera_y], hl
	return
_zerowidth:
	mov b, 6 << 8
	ret
_zeroheight:
	mov b, 4 << 8
	ret
	end_function 0
.endif
.macro c_map8_campos x, y
	cinvoke2 c_map8_campos, x, y
.endm

; ] Move camera relatively along x-axis
; | c_map8_movex num
; *   num         - Pixels to move along x-axis (Fixed 12.4)
	declare_function "c_map8_movex", 0, 1
.ifdef c_map8_movex_cinvoked
	begin_function
	mov i, 0
	getparam 0, REG_BA
	tst b, $80
	jnzb _neg
	mov hl, [map8_camera_x]
	add hl, ba
	mov b, [pmmap8ram_width]
	cmp b, 12
	jcb :ff
	mov a, 0
	sub ba, 12 << 8
	shr b
	cmp hl, ba
	jcb :f
	mov hl, ba
:	mov [map8_camera_x], hl
	return
:	mov hl, 0
	mov [map8_camera_x], hl
	return
_neg:
	mov hl, [map8_camera_x]
	add hl, ba
	jcb :f
	mov hl, 0
:	mov [map8_camera_x], hl
	end_function 0
.endif
.macro c_map8_movex num
	cinvoke1 c_map8_movex, num
.endm

; ] Move camera relatively along y-axis
; | c_map8_movey num
; *   num         - Pixels to move along y-axis (Fixed 12.4)
	declare_function "c_map8_movey", 0, 1
.ifdef c_map8_movey_cinvoked
	begin_function
	mov i, 0
	getparam 0, REG_BA
	tst b, $80
	jnzb _neg
	mov hl, [map8_camera_y]
	add hl, ba
	mov b, [pmmap8ram_height]
	cmp b, 8
	jcb :ff
	mov a, 0
	sub ba, 8 << 8
	shr b
	cmp hl, ba
	jcb :f
	mov hl, ba
:	mov [map8_camera_y], hl
	return
:	mov hl, 0
	mov [map8_camera_y], hl
	return
_neg:
	mov hl, [map8_camera_y]
	add hl, ba
	jcb :f
	mov hl, 0
:	mov [map8_camera_y], hl
	end_function 0
.endif
.macro c_map8_movey num
	cinvoke1 c_map8_movey, num
.endm

; ] Check if specific coordinate is valid
; | c_map8_validcoord x, y
; *   x           - Pixel x-coordinate (Fixed 12.4)
; *   y           - Pixel y-coordinate (Fixed 12.4)
; # return_to : zero if invalid, non-zero otherwise
	declare_function "c_map8_validcoord", 0, 2
.ifdef c_map8_validcoord_cinvoked
	begin_function
	getparam 0, REG_UA
	mov b, [pmmap8ram_width]
	cmp a, b
	returnc_with nc, 0
	getparam 1, REG_UA
	mov b, [pmmap8ram_height]
	cmp a, b
	returnc_with nc, 0
	mov ba, 1
	end_function 0
.endif
.macro c_map8_validcoord x, y
	cinvoke2 c_map8_validcoord, x, y
.endm

; ] Get ID from map at specific coordinate
; | c_map8_gettile x, y
; *   x           - Pixel x-coordinate (Fixed 12.4)
; *   y           - Pixel y-coordinate (Fixed 12.4)
; # return_to : Tile ID (0 to 255)
	declare_function "c_map8_gettile", 0, 2
.ifdef c_map8_gettile_cinvoked
	begin_function
	mov a, [pmmap8ram_mapaddr+2]
	mov xi, a
	mov x, [pmmap8ram_mapaddr]
	getparam 0, REG_UL
	mov h, 0
	add x, hl
	jncb :f
	mov a, xi
	inc a
	mov xi, a
:	getparam 1, REG_UL
	mov a, [pmmap8ram_width]
	mul l, a
	add x, hl
	jncb :f
	mov a, xi
	inc a
	mov xi, a
:	mov a, [x]
	end_function ENDF_BYTE
.endif
.macro c_map8_gettile x, y
	cinvoke2 c_map8_gettile, x, y
.endm

; ] Get code from external map at specific coordinate
; | c_map8_getcode x, y, map_addr, map_width
; *   x           - Pixel x-coordinate (Fixed 12.4)
; *   y           - Pixel y-coordinate (Fixed 12.4)
; *   map_addr    - Map address (16x16 tiles format)
; *   map_width   - Map width
; # return_to : 8-Bits code (0 to 255)
	declare_function "c_map8_getcode", PTR_3, 5
.ifdef c_map8_getcode_cinvoked
	begin_function
	getparam 3, REG_A
	mov xi, a
	getparam_ihl 2, REG_X
	getparam 0, REG_HL
	add hl, hl
	mov l, h
	mov h, 0
	add x, hl
	jncb :f
	mov a, xi
	inc a
	mov xi, a
:	getparam 1, REG_HL
	add hl, hl
	mov l, h
	getparam 4, REG_A
	mul l, a
	add x, hl
	jncb :f
	mov a, xi
	inc a
	mov xi, a
:	mov a, [x]
	end_function ENDF_BYTE
.endif
.macro c_map8_getcode x, y, map_addr, map_width
	cinvoke2 c_map8_getcode, x, y, map_addr, map_width
.endm

; ] Get OAM sprite position from position and camera
; | c_map8_sprpos x, y
; *   x           - Sprite pixel x-coordinate (Fixed 12.4)
; *   y           - Sprite pixel y-coordinate (Fixed 12.4)
; # return_to: zero if outside or reg B = OAM Y and reg A = OAM X
	declare_function "c_map8_sprpos", 0, 2
.ifdef c_map8_sprpos_cinvoked
	varlocal _tmp 1
	begin_function
	mov i, 0
	getparam_ihl 2, REG_X
	getparam 0, REG_HL
	add hl, 15 << 4
	and l, $F0
	mov ba, [map8_camera_x]
	and a, $F0
	sub hl, ba
	mov ba, 6 << 8
	add ba, 15 << 4
	cmp hl, ba
	jcb :f
	return_with 0
:	sub hl, 15 << 4
	add hl, hl
	add hl, hl
	add hl, hl
	add hl, hl
	setlocalb 0, REG_H
	getparam_ihl 3, REG_X
	getparam 1, REG_HL
	add hl, 15 << 4
	and l, $F0
	mov ba, [map8_camera_y]
	and a, $F0
	sub hl, ba
	mov ba, 4 << 8
	add ba, 15 << 4
	cmp hl, ba
	jcb :f
	return_with 0
:	sub hl, 15 << 4
	add hl, hl
	add hl, hl
	add hl, hl
	add hl, hl
	add hl, $1000
	mov b, h
	getlocalb 0, REG_A
	add a, $10
	end_function 0
.endif
.macro c_map8_sprpos x, y
	cinvoke2 c_map8_sprpos, x, y
.endm



.ifdef c_map8_set_cinvoked

	.ram pmmap8ram_mapaddr     3
	.ram pmmap8ram_width       1
	.ram pmmap8ram_height      1

	.ram pmmap8ram_scrwidth    1
	.ram pmmap8ram_screxptc    2

	.ram map8_camera_x         2
	.ram map8_camera_y         2

.endif
