; Copyright (C) 2012 by JustBurn
;
; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:
;
; The above copyright notice and this permission notice shall be included in
; all copies or substantial portions of the Software.
;
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
; THE SOFTWARE.

.ifndef PM_CSTYLE
.error "pm_cstyle.s must be included"
.endif

.if . < 0x2200
.error "pmrom_cout.s file must be included after pm_header"
.endif


; ] Clear all debug output
; | c_out_clear
	declare_function "c_out_clear", 0, 0
.ifdef c_out_clear_cinvoked
	begin_function
	mov ba, 0x431B
	mov [n+POKEMINI_CHR], a
	mov [n+POKEMINI_CHR], b
	end_function 0
.endif
.macro c_out_clear
	cinvoke0 c_out_clear
.endm


; ] Lock debug output
; | c_out_lock
	declare_function "c_out_lock", 0, 0
.ifdef c_out_lock_cinvoked
	begin_function
	mov ba, 0x4C1B
	mov [n+POKEMINI_CHR], a
	mov [n+POKEMINI_CHR], b
	end_function 0
.endif
.macro c_out_lock
	cinvoke0 c_out_lock
.endm


; ] Unlock debug output
; | c_out_unlock
	declare_function "c_out_unlock", 0, 0
.ifdef c_out_unlock_cinvoked
	begin_function
	mov ba, 0x551B
	mov [n+POKEMINI_CHR], a
	mov [n+POKEMINI_CHR], b
	end_function 0
.endif
.macro c_out_unlock
	cinvoke0 c_out_unlock
.endm


; ] Print string to debug output with line-feed
; | c_out_puts string_addr
; *   string_addr - source address
	declare_function "c_out_puts", PTR_1, 2
.ifdef c_out_puts_cinvoked
	begin_function
	getparam 1, REG_A
	mov i, a
	getparam 0, REG_HL
	mov a, [hl]
	cmp a, 0
	jzb :ff
	inc hl
:	mov [n+POKEMINI_CHR], a
	mov a, [hl]
	inc hl
	inc y
	cmp a, 0
	jnzb :b
:	mov [n+POKEMINI_CHR], 0x0A
	end_function 0
.endif
.macro c_out_puts string_addr
	cinvoke1 c_out_puts, string_addr
.endm


; ] Print string to debug output
; | c_out_prints string_addr
; *   string_addr - source address
	declare_function "c_out_prints", PTR_1, 2
.ifdef c_out_prints_cinvoked
	begin_function
	getparam 1, REG_A
	mov i, a
	getparam 0, REG_HL
	mov a, [hl]
	cmp a, 0
	returnc z
	inc hl
:	mov [n+POKEMINI_CHR], a
	mov a, [hl]
	inc hl
	inc y
	cmp a, 0
	jnzb :b
	end_function 0
.endif
.macro c_out_prints string_addr
	cinvoke1 c_out_prints, string_addr
.endm


; ] Print character to debug output
; | c_out_printc charv
; *   charv - 8-bits ASCII character
	declare_function "c_out_printc", 0, 1
.ifdef c_out_printc_cinvoked
	begin_function
	getparam 0, REG_A
	mov [n+POKEMINI_CHR], a
	end_function 0
.endif
.macro c_out_printc charv
	cinvoke1 c_out_printc, charv
.endm


; ] Print unsigned 8-bits decimal to debug output
; | c_out_printub number
; *   number - 8-bits number
	declare_function "c_out_printub", 0, 1
.ifdef c_out_printub_cinvoked
	begin_function
	getparam 0, REG_A
	mov [n+POKEMINI_UINTB], a
	end_function 0
.endif
.macro c_out_printub number
	cinvoke1 c_out_printub, number
.endm


; ] Print unsigned 16-bits decimal to debug output
; | c_out_printuw number
; *   number - 16-bits number
	declare_function "c_out_printuw", 0, 1
.ifdef c_out_printuw_cinvoked
	begin_function
	getparam 0, REG_BA
	mov i, 0
	mov [REG_BASE+POKEMINI_UINTW], ba
	end_function 0
.endif
.macro c_out_printuw number
	cinvoke1 c_out_printuw, number
.endm


; ] Print signed 8-bits decimal to debug output
; | c_out_printsb number
; *   number - 8-bits number
	declare_function "c_out_printsb", 0, 1
.ifdef c_out_printsb_cinvoked
	begin_function
	getparam 0, REG_A
	mov [n+POKEMINI_SINTB], a
	end_function 0
.endif
.macro c_out_printsb number
	cinvoke1 c_out_printsb, number
.endm


; ] Print signed 16-bits decimal to debug output
; | c_out_printw number
; *   number - 16-bits number
	declare_function "c_out_printsw", 0, 1
.ifdef c_out_printsw_cinvoked
	begin_function
	getparam 0, REG_BA
	mov i, 0
	mov [REG_BASE+POKEMINI_SINTW], ba
	end_function 0
.endif
.macro c_out_printsw number
	cinvoke1 c_out_printsw, number
.endm


; ] Print 8-bits hexadecimal number to debug output
; | c_out_printhb number
; *   number - 8-bits number
	declare_function "c_out_printhb", 0, 1
.ifdef c_out_printhb_cinvoked
	begin_function
	getparam 0, REG_A
	mov [n+POKEMINI_HEX], a
	end_function 0
.endif
.macro c_out_printhb number
	cinvoke1 c_out_printhb, number
.endm


; ] Print 16-bits hexadecimal number to debug output
; | c_out_printhw number
; *   number - 16-bits number
	declare_function "c_out_printhw", 0, 1
.ifdef c_out_printhw_cinvoked
	begin_function
	getparam 0, REG_BA
	mov [REG_BASE+POKEMINI_HEX], b
	mov [REG_BASE+POKEMINI_HEX], a
	end_function 0
.endif
.macro c_out_printhw number
	cinvoke1 c_out_printhw, number
.endm


; ] Print fixed-point 8.8 to debug output
; | c_out_printf8 number
; *   number - 8-bits number
	declare_function "c_out_printf8", 0, 1
.ifdef c_out_printf8_cinvoked
	begin_function
	getparam 0, REG_BA
	mov i, 0
	mov [REG_BASE+POKEMINI_FX8], ba
	end_function 0
.endif
.macro c_out_printf8 number
	cinvoke1 c_out_printf8, number
.endm
