; Copyright (C) 2012 by JustBurn
;
; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:
;
; The above copyright notice and this permission notice shall be included in
; all copies or substantial portions of the Software.
;
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
; THE SOFTWARE.

.ifndef PM_CSTYLE
.error "pm_cstyle.s must be included"
.endif

.if . < 0x2200
.error "pmrom_cspr.s file must be included after pm_header"
.endif


.equ	CSPR_HFLIP	$0100
.equ	CSPR_VFLIP	$0200
.equ	CSPR_INVERT	$0400

; ] Clear sprites list
; | c_spr_clear
	declare_function "c_spr_clear", 0, 0
.ifdef c_spr_clear_cinvoked
	begin_function
	xor a, a
	mov xi, a
	mov x, pmsprram_list
	mov [x+$03], a
	mov [x+$07], a
	mov [x+$0B], a
	mov [x+$0F], a
	mov [x+$13], a
	mov [x+$17], a
	mov [x+$1B], a
	mov [x+$1F], a
	mov [x+$23], a
	mov [x+$27], a
	mov [x+$2B], a
	mov [x+$2F], a
	mov [x+$33], a
	mov [x+$37], a
	mov [x+$3B], a
	mov [x+$3F], a
	mov [x+$43], a
	mov [x+$47], a
	mov [x+$4B], a
	mov [x+$4F], a
	mov [x+$53], a
	mov [x+$57], a
	mov [x+$5B], a
	mov [x+$5F], a
	mov [pmsprram_soff], a
	end_function 0
.endif
.macro c_spr_clear
	cinvoke0 c_spr_clear
.endm

; ] Update sprites list into hardware
; | c_spr_update
	declare_function "c_spr_update", 0, 0
.ifdef c_spr_update_cinvoked
	begin_function
	mov xi, 0
	mov x, pmsprram_list
	mov y, SPR_BASE
	mov b, 12
:	mov [y], [x]
	inc x
	inc y
	mov [y], [x]
	inc x
	inc y
	mov [y], [x]
	inc x
	inc y
	mov [y], [x]
	inc x
	inc y
	mov [y], [x]
	inc x
	inc y
	mov [y], [x]
	inc x
	inc y
	mov [y], [x]
	inc x
	inc y
	mov [y], [x]
	inc x
	inc y
	jdbnz :b
	end_function 0
.endif
.macro c_spr_update
	cinvoke0 c_spr_update
.endm

; ] Add sprite to list
; | c_spr_add pos, tile
; *   pos         - Sprite position : Low byte -> OAM X, High byte -> OAM Y
; *   tile        - Sprite tile and control
; # return_to : -1 = sprite offscreen, 0 = sprites list full, 1 = sprite added
	declare_function "c_spr_add", 0, 2
.ifdef c_spr_add_cinvoked
	begin_function
	mov a, [pmsprram_soff]
	cmp a, 96
	returnc_with z, 0
	getparam_ihl 0, REG_X
	cmp x, 0
	returnc_with z, $FFFF
	mov i, 0
	mov b, 0
	mov hl, pmsprram_list
	add hl, ba
	mov [hl], x
	inc hl
	inc hl
	getparam 1, REG_BA
	or b, SPR_ENABLE
	mov [hl], ba
	mov hl, pmsprram_soff
	add [hl], 4
	mov ba, 1
	end_function 0
.endif
.macro c_spr_add pos, tile
	cinvoke2 c_spr_add pos, tile
.endm


.ifdef c_spr_update_cinvoked

	.ram pmsprram_soff 1
	.ram pmsprram_list 96

.endif
