; Copyright (C) 2012 by JustBurn
;
; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:
;
; The above copyright notice and this permission notice shall be included in
; all copies or substantial portions of the Software.
;
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
; THE SOFTWARE.

.ifndef PM_CSTYLE
.error "pm_cstyle.s must be included"
.endif

.if . < 0x2200
.error "pmrom_cstd.s file must be included after pm_header"
.endif


; ] Get keypad status
; | c_keypad
; # return_to: A = Keys
	declare_function "c_keypad", 0, 0
.ifdef c_keypad_cinvoked
	begin_function
	mov b, 0
:	mov a, [REG_BASE+KEY_PAD]
	push a
	xor a, b
	cmp a, 0
	pop a
	mov b, a
	jnzb :b
	not a
	end_function ENDF_BYTE
.endif
.macro c_keypad
	cinvoke0 c_keypad
.endm


; ] Get string length
; | c_strlen string_addr
; *   string_addr - string address
; # return_to: number of characters not including the null-termination
	declare_function "c_strlen", PTR_1, 2
.ifdef c_strlen_cinvoked
	begin_function
	getparam 1, REG_A
	mov i, a
	getparam 0, REG_HL
	mov ba, 0
	cmp [hl], 0
	returnc z
:	inc hl
	inc ba
	cmp [hl], 0
	jnzb :b
	end_function 0
.endif
.macro c_strlen string_addr
	cinvoke1 c_strlen, string_addr
.endm


; ] Copy string to RAM
; | c_strcpy dest_ram, string_addr
; *   dest_ram    - destination ram address
; *   string_addr - string address
	declare_function "c_strcpy", PTR_2, 3
.ifdef c_strcpy_cinvoked
	begin_function
	getparam 2, REG_A
	mov xi, a
	getparam_iba 1, REG_X
	getparam_iba 0, REG_Y_DESTROY
	mov a, [x]
	cmp a, 0
	returnc z
	inc x
:	mov [y], a
	mov a, [x]
	inc x
	inc y
	cmp a, 0
	jnzb :b
	end_function 0
.endif
.macro c_strcpy dest_ram, string_addr
	cinvoke2 c_strcpy, dest_ram, string_addr
.endm


; ] Copy block of memory to RAM
; | c_memcpy dest_ram, src_addr, sizen
; *   dest_ram   - destination ram address
; *   block_addr - block address
; *   sizen      - number of bytes
	declare_function "c_memcpy", PTR_2, 4
.ifdef c_memcpy_cinvoked
	begin_function
	getparam 3, REG_HL
	cmp hl, 0
	returnc z
	getparam 2, REG_A
	mov xi, a
	getparam_iba 1, REG_X
	getparam_iba 0, REG_Y_DESTROY
:	mov [y], [x]
	inc x
	inc y
	dec hl
	jnzb :b
	end_function 0
.endif
.macro c_memcpy dest_ram, src_addr, sizen
	cinvoke3 c_memcpy, dest_ram, src_addr, sizen
.endm


; ] Fill block of memory in RAM
; | c_memset dest_ram, value, sizen
; *   dest_ram - destination ram address
; *   value    - 8-bits value
; *   sizen    - number of bytes
	declare_function "c_memset", 0, 3
.ifdef c_memset_cinvoked
	begin_function
	getparam 1, REG_A
	push a
	getparam_iba 2, REG_HL
	getparam_iba 0, REG_Y_DESTROY
	pop a
	cmp hl, 0
	returnc z
:	mov [y], a
	inc y
	dec hl
	jnzb :b
	end_function 0
.endif
.macro c_memset dest_ram, value, sizen
	cinvoke3 c_memset, dest_ram, value, sizen
.endm


; ] Compare two strings
; | c_strcmp string1_addr, string2_addr
; *   string1_addr - 1st string address
; *   string2_addr - 2nd string address
	declare_function "c_strcmp", PTR_1|PTR_2, 4
.ifdef c_strcmp_cinvoked
	begin_function
	getparam 1, REG_A
	mov xi, a
	getparam 3, REG_A
	getparam_ihl 0, REG_X
	getparam_ihl 2, REG_Y_DESTROY
	mov yi, a
	mov a, [x]
	mov b, [y]
	sub a, b
	jns :f
	mov b, $FF
	return
:	cmp b, 0
	jnzb :f
	mov b, 0
	return
:	inc x
	inc y
	mov a, [x]
	mov b, [y]
	sub a, b
	jzb :bb
	mov b, 0
	returnc ns
	mov b, $FF
	end_function ENDF_RESTORE_YI
.endif
.macro c_strcmp string1_addr, string2_addr
	cinvoke2 c_strcmp, string1_addr, string2_addr
.endm


; ] Compare two blocks of memory
; | c_memcmp block1_addr, block2_addr, sizen
; *   block1_ram - 1st block address
; *   block2_ram - 2nd block address
; *   sizen     - number of bytes to compare
	declare_function "c_memcmp", PTR_1|PTR_2, 5
.ifdef c_memcmp_cinvoked
	begin_function
	getparam 4, REG_HL
	cmp hl, 0
	returnc z
	dec hl
	getparam 1, REG_A
	mov xi, a
	getparam 2, REG_A
	push a
	getparam_iba 0, REG_X
	getparam_iba 2, REG_Y_DESTROY
	pop a
	mov yi, a
	mov a, [x]
	mov b, [y]
	sub a, b
	jns :f
	mov b, $FF
	return
:	cmp hl, 0
	jnzb :f
	mov b, 0
	return
:	inc x
	inc y
	dec hl
	mov a, [x]
	mov b, [y]
	sub a, b
	jzb :bb
	mov b, 0
	returnc ns
	mov b, $FF
	end_function ENDF_RESTORE_YI
.endif
.macro c_memcmp block1_addr, block2_addr, sizen
	cinvoke3 c_memcmp, block1_addr, block2_addr, sizen
.endm
