; Copyright (C) 2012 by JustBurn
;
; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:
;
; The above copyright notice and this permission notice shall be included in
; all copies or substantial portions of the Software.
;
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
; THE SOFTWARE.

.ifndef PM_CSTYLE
.error "pm_cstyle.s must be included"
.endif

.if . < 0x2200
.error "pmrom_cstr.s file must be included after pm_header"
.endif


; ] Print string to buffer
; | c_str_prints ramaddr, string_addr
; *   ramaddr     - address to store string
; *   string_addr - source address
; # return_to: address of null character
	declare_function "c_str_prints", PTR_2, 3
.ifdef c_str_prints_cinvoked
	begin_function
	getparam 2, REG_A
	mov i, 0
	mov xi, a
	getparam_iba 1, REG_X
	getparam_iba 0, REG_HL
	mov a, [x]
	cmp a, 0
	jzb :ff
	inc x
:	mov [hl], a
	inc hl
	mov a, [x]
	inc x
	cmp a, 0
	jnzb :b
:	mov ba, hl
	end_function 0
.endif
.macro c_str_prints ramaddr, string_addr
	cinvoke2 c_str_prints, ramaddr, string_addr
.endm


; ] Print character to buffer
; | c_str_printc charv
; *   ramaddr - address to store string
; *   charv  - 8-bits ASCII character
; # return_to: address of null character
	declare_function "c_str_printc", 0, 2
.ifdef c_str_prints_cinvoked
	begin_function
	getparam 2, REG_A
	getparam 0, REG_HL
	mov [hl], a
	inc hl
	mov ba, hl
	end_function 0
.endif
.macro c_str_printc ramaddr, charv
	cinvoke2 c_str_printc, ramaddr, charv
.endm


; ] Print unsigned 8-bits decimal to buffer
; | c_str_printub ramaddr, number
; *   ramaddr - address to store string
; *   number  - 8-bits number
; # return_to: address of null character
	declare_function "c_str_printub", 0, 2
.ifdef c_str_printub_cinvoked
	begin_function
	mov i, 0
	mov a, 10
	mov h, 0
	mov b, h
	getparam 1, REG_L
:	mov h, 0
	div hl, a
	push h
	inc b
	cmp l, 0
	jnz :b
	getparam 0, REG_HL
:	pop a
	add a, $30
	mov [hl], a
	inc hl
	jdbnz :b
	mov ba, hl
	end_function 0
.endif
.macro c_str_printub ramaddr, number
	cinvoke2 c_str_printub, ramaddr, number
.endm


; ] Print unsigned 16-bits decimal to buffer
; | c_str_printuw ramaddr, number
; *   ramaddr - address to store string
; *   number  - 16-bits number
; # return_to: address of null character
	declare_function "c_str_printuw", 0, 2
.ifdef c_str_printuw_cinvoked
	begin_function
	getparam_iba 1, REG_X
	mov i, 0
	mov l, 0
:	cinvoke2 c_umod, REG_X, 10
	push a
	inc l
	cmp x, 0
	jnz :b
	mov b, l
	getparam 0, REG_HL
:	pop a
	add a, $30
	mov [hl], a
	inc hl
	jdbnz :b
	mov ba, hl
	end_function 0
.endif
.macro c_str_printuw ramaddr, number
	cinvoke2 c_str_printuw, ramaddr, number
.endm


; ] Print signed 8-bits decimal to buffer
; | c_str_printsb ramaddr, number
; *   ramaddr - address to store string
; *   number  - 8-bits number
; # return_to: address of null character
	declare_function "c_str_printsb", 0, 2
.ifdef c_str_printsb_cinvoked
	begin_function
	getparam 0, REG_BA
	mov i, 0
	getparam 1, REG_L
	cmp l, $80
	jcb :f
	push l
	getparam 0, REG_HL
	mov [hl], '-'
	inc hl
	setparam 0, REG_HL
	pop l
	mov a, l
	neg a
	mov l, a
:	mov a, 10
	mov h, 0
	mov b, h
:	mov h, 0
	div hl, a
	push h
	inc b
	cmp l, 0
	jnz :b
	getparam 0, REG_HL
:	pop a
	add a, $30
	mov [hl], a
	inc hl
	jdbnz :b
	mov ba, hl
	end_function 0
.endif
.macro c_str_printsb ramaddr, number
	cinvoke2 c_str_printsb, ramaddr, number
.endm


; ] Print signed 16-bits decimal to buffer
; | c_str_printw ramaddr, number
; *   ramaddr - address to store string
; *   number  - 16-bits number
; # return_to: address of null character
	declare_function "c_str_printsw", 0, 2
.ifdef c_str_printsw_cinvoked
	begin_function
	getparam_iba 1, REG_X
	cmp x, $8000
	jcb :f
	getparam 0, REG_HL
	mov [hl], '-'
	inc hl
	setparam 0, REG_HL
	mov ba, 0
	sub ba, x
	mov x, ba
:	mov i, 0
	mov l, 0
:	cinvoke2 c_umod, REG_X, 10
	push a
	inc l
	cmp x, 0
	jnz :b
	mov b, l
	getparam 0, REG_HL
:	pop a
	add a, $30
	mov [hl], a
	inc hl
	jdbnz :b
	mov ba, hl
	end_function 0
.endif
.macro c_str_printsw ramaddr, number
	cinvoke2 c_str_printsw, ramaddr, number
.endm


; ] Print 8-bits hexadecimal number to buffer
; | c_str_printhb ramaddr, number
; *   ramaddr - address to store string
; *   number  - 8-bits number
; # return_to: address of null character
	declare_function "c_str_printhb", 0, 2
.ifdef c_str_printhb_cinvoked
	begin_function
	mov i, 0
	mov xi, c_str_hexadecimal_table >> 16
	mov x, c_str_hexadecimal_table & 0xFFFF
	getparam 1, REG_A
	unpack
	mov l, a
	mov a, [x+l]
	mov l, b
	mov b, [x+l]
	getparam 0, REG_HL
	mov [hl], b
	inc hl
	mov [hl], a
	inc hl
	mov ba, hl
	end_function 0
.endif
.macro c_str_printhb ramaddr, number
	cinvoke2 c_str_printhb, ramaddr, number
.endm


; ] Print 16-bits hexadecimal number to buffer
; | c_str_printhw ramaddr, number
; *   ramaddr - address to store string
; *   number  - 16-bits number
; # return_to: address of null character
	declare_function "c_str_printhw", 0, 2
.ifdef c_str_printhw_cinvoked
	begin_function
	mov i, 0
	mov xi, c_str_hexadecimal_table >> 16
	mov x, c_str_hexadecimal_table & 0xFFFF
	getparam 1, REG_UA
	unpack
	mov l, a
	mov a, [x+l]
	mov l, b
	mov b, [x+l]
	getparam 0, REG_HL
	mov [hl], b
	inc hl
	mov [hl], a
	inc hl
	getparam 1, REG_A
	unpack
	push l
	mov l, a
	mov a, [x+l]
	mov l, b
	mov b, [x+l]
	pop l
	mov [hl], b
	inc hl
	mov [hl], a
	inc hl
	mov ba, hl
	end_function 0
.endif
.macro c_str_printhw ramaddr, number
	cinvoke2 c_str_printhw, ramaddr, number
.endm


; ] Print fixed-point 8.8 to buffer
; | c_str_printf8 ramaddr, number
; *   ramaddr - address to store string
; *   number  - fixed-point 8.8 number
; # return_to: address of null character
	declare_function "c_str_printf8", 0, 2
.ifdef c_str_printf8_cinvoked
	begin_function
	getparam 0, REG_BA
	mov i, 0
	mov xi, c_str_fractional_table >> 16
	getparam 1, REG_HL
	cmp h, $80
	jcb :ff
	cmp l, $00
	jz :f
	inc h
:	push h
	getparam 0, REG_HL
	mov [hl], '-'
	inc hl
	setparam 0, REG_HL
	pop h
	mov a, h
	neg a
	mov h, a
:	mov a, 10
	mov l, h
	mov b, 0
:	mov h, 0
	div hl, a
	push h
	inc b
	cmp l, 0
	jnz :b
	getparam 0, REG_HL
:	pop a
	add a, $30
	mov [hl], a
	inc hl
	jdbnz :b
	mov [hl], '.'
	inc hl
	push hl
	getparam 1, REG_BA
	tst b, $80
	jzb :f
	neg a
:	shr a
	shr a
	mov x, c_str_fractional_table & 0xFFFF
	mov b, 0
	add x, ba
	mov a, [x]
	mov x, c_str_hexadecimal_table & 0xFFFF
	unpack
	mov l, a
	mov a, [x+l]
	mov l, b
	mov b, [x+l]
	pop hl
	mov [hl], b
	inc hl
	mov [hl], a
	inc hl
	mov ba, hl
	end_function 0
.endif
.macro c_str_printf8 ramaddr, number
	cinvoke2 c_str_printf8, ramaddr, number
.endm


.set c_str_hexadecimal_table_available 0
.ifdef c_str_printfs_cinvoked
.set c_str_hexadecimal_table_available 1
.endif
.ifdef c_str_printhb_cinvoked
.set c_str_hexadecimal_table_available 1
.endif
.ifdef c_str_printhw_cinvoked
.set c_str_hexadecimal_table_available 1
.endif
.ifdef c_str_printf8_cinvoked
.set c_str_hexadecimal_table_available 1
.endif

.if (c_str_hexadecimal_table_available == 1)
c_str_hexadecimal_table:
	.db "0123456789ABCDEF"
.endif


.set c_str_fractional_table_available 0
.ifdef c_str_printf8_cinvoked
.set c_str_fractional_table_available 1
.endif

.if (c_str_fractional_table_available == 1)
c_str_fractional_table:
	.db $00,$02,$03,$05,$06,$08,$09,$11,$13,$14,$16,$17,$19,$20,$22,$23
	.db $25,$27,$28,$30,$31,$33,$34,$36,$38,$39,$41,$42,$44,$45,$47,$48
	.db $50,$52,$53,$55,$56,$58,$59,$61,$63,$64,$66,$67,$69,$70,$72,$73
	.db $75,$77,$78,$80,$81,$83,$84,$86,$88,$89,$91,$92,$94,$95,$97,$98
.endif
